(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.domical = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
__export(require("domic-i18n"));
__export(require("domic-app"));
__export(require("domic-material"));
__export(require("domic"));

},{"domic":5,"domic-app":2,"domic-i18n":3,"domic-material":4}],2:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var domic_1 = require("domic");
/**
 *
 */
var ServiceConfig = (function () {
    function ServiceConfig(service) {
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        this.params = [];
        this.service = service;
        this.params = params;
    }
    return ServiceConfig;
}());
exports.ServiceConfig = ServiceConfig;
/**
 *
 */
var Redirect = (function (_super) {
    __extends(Redirect, _super);
    function Redirect(screen, configs) {
        var _this = _super.call(this, 'redirecting') || this;
        _this.screen = screen;
        _this.configs = configs;
        return _this;
    }
    return Redirect;
}(Error));
/**
 * Resolver helps in service instanciation and destroy
 */
var Resolver = (function () {
    function Resolver(app) {
        this.app = app;
    }
    /**
     *  For a given service type, return an instance, creating it
     *  if it doesn't exist, using a matching ServiceConfig if provided.
     *
     *  If this is not the first time the service is instanciated, try
     *  to reuse a previous instance as long as its config or any of its
     *  dependencies have not changed.
     *
     *  @param type: A Service type
     *  @returns: The matching service instance
     */
    Resolver.prototype.require = function (type) {
        var service = this.services.get(type);
        if (service)
            return service;
        var conf = this.configs.get(type);
        if (conf) {
            // we ignore previous service, since we are being given a new
            // configuration for it.
            service = new (type.bind.apply(type, [void 0, this.app].concat(conf.params)))();
        }
        else {
            // try to get an older version of the service since possibly its
            // configuration has not changed.
            service = this.old_resolver ? this.old_resolver.services.get(type) : null;
            conf = this.old_resolver ? this.old_resolver.configs.get(type) : null;
            if (service) {
                // browse the dependencies and check that they haven't changed themselves.
                // if require() sends a different instance of the dependency, this service
                // is not reused.
                for (var _i = 0, _a = service._dependencies; _i < _a.length; _i++) {
                    var d_1 = _a[_i];
                    var nd = this.require(d_1.constructor);
                    if (d_1 !== nd)
                        service = null;
                }
            }
            if (!service) {
                // no config, no previously instanciated service, so
                // we just create one without arguments, reusing its config if it had one previously.
                var params = conf ? conf.params : [];
                service = new (type.bind.apply(type, [void 0, this.app].concat(params)))();
            }
            // pull the old configuration into the new map to keep track of it.
            if (conf)
                this.configs.set(type, conf);
        }
        this.services.set(type, service);
        return service;
    };
    /**
     * Destroy services that won't be used anymore by calling their destroy()
     * method.
     */
    Resolver.prototype.commit = function () {
        var _this = this;
        // Destroy old service versions.
        if (this.old_resolver) {
            this.old_resolver.services.forEach(function (serv, type) {
                if (_this.services.get(type) !== serv) {
                    serv.destroy();
                }
            });
        }
        // free the old resolver so it can be garbage collected.
        this.old_resolver = null;
    };
    /**
     * Call all the init() of the services.
     *
     * @returns: A promise of when the initiation will be done.
     */
    Resolver.prototype.init = function () {
        var promises = [];
        this.services.forEach(function (serv) {
            // Setup the promise chain ; basically, getInitPromise gets all the dependencies promises
            // and will make their init() method wait on them.
            promises.push(serv.getInitPromise(serv._dependencies.map(function (d) { return d.getInitPromise(); })));
        });
        return Promise.all(promises);
    };
    /**
     * Prepare the resolver for a new transition.
     */
    Resolver.prototype.prepare = function (screen, old_resolver, configs) {
        var _this = this;
        // Setup the config map
        this.configs = new Map();
        this.services = new Map();
        this.old_resolver = old_resolver;
        configs.forEach(function (conf) { return _this.configs.set(conf.service, conf); });
        screen.deps.forEach(function (dep) { return _this.require(dep); });
    };
    return Resolver;
}());
exports.Resolver = Resolver;
/**
 * Application
 */
var App = (function () {
    function App() {
        var _this = this;
        this.activating = false;
        this.current_screen = null;
        this.resolver = null;
        this.state_stack = [];
        this.current_state_index = -1;
        this.o_services = domic_1.o(null);
        window.addEventListener('popstate', function (ev) {
            _this.popstate(ev.state.state_index);
        });
    }
    App.prototype.block = function (name) {
        var block = function _block() {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            var v = new View(this);
            var fn = a[a.length - 1];
            var services = a.slice(0, a.length - 1);
            v.fn = fn;
            v.deps = services;
            v.block = block;
            v.app = block.app;
            return v;
        };
        block.app = this;
        block._name = name;
        return block;
        // return new Block(this)
    };
    App.prototype.screen = function (name) {
        var views = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            views[_i - 1] = arguments[_i];
        }
        var screen = new Screen(this, name);
        screen.define.apply(screen, views);
        return screen;
    };
    /**
     *
     */
    App.prototype.go = function (screen) {
        var _this = this;
        var configs = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            configs[_i - 1] = arguments[_i];
        }
        if (this.activating)
            // Should do some kind of redirect here ?
            return Promise.reject(new Redirect(screen, configs));
        try {
            this.activating = true;
            var prev_resolver_1 = this.resolver;
            this.resolver = new Resolver(this);
            this.resolver.prepare(screen, prev_resolver_1, configs);
            // wait on all the promises before transitionning to a new state.
            return this.resolver.init().then(function (res) {
                _this.resolver.commit();
                _this.config = _this.resolver.configs;
                _this.services = _this.resolver.services;
                _this.current_screen = screen;
                _this.activating = false;
                _this.o_services.set(_this.services);
                // Replace state stack to remove all possible forward occurences...
                // XXX : forward is bugged ?
                _this.state_stack = _this.state_stack.slice(0, _this.current_state_index + 1);
                // Push
                _this.state_stack.push({
                    screen: _this.current_screen,
                    config: _this.config
                });
                _this.current_state_index = _this.state_stack.length - 1;
                window.history.pushState({ state_index: _this.state_stack.length - 1 }, null);
            }).catch(function (err) {
                // cancel activation.
                _this.resolver = prev_resolver_1;
                _this.activating = false;
                if (err.message === 'redirecting' && err.screen)
                    return _this.go.apply(_this, [err.screen].concat(err.configs));
                return Promise.reject(err);
            });
        }
        catch (err) {
            this.activating = false;
            return Promise.reject(err);
        }
    };
    App.prototype.popstate = function (idx) {
        return __awaiter(this, void 0, void 0, function () {
            var state, configs, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.state_stack.length === 0)
                            return [2 /*return*/, Promise.reject('no previous screen')];
                        state = this.state_stack[idx];
                        configs = [];
                        state.config.forEach(function (value) { return configs.push(value); });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.go.apply(this, [state.screen].concat(configs))];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     */
    App.prototype.require = function (type) {
        return this.resolver.require(type);
    };
    return App;
}());
exports.App = App;
/**
 * A sample app, usable by default
 */
exports.app = new App;
/**
 *
 */
var Service = (function () {
    function Service(app) {
        this.ondestroy = [];
        this._dependencies = [];
        this.app = app;
    }
    // static with<Z, A, B, C, D, E, F>(this: new (app: App, a: A, b: B, c: C, d: D, e: E, f: F) => Z, a: A, b: B, c: C, d: D, e: E, f: F): ServiceConfig;
    // static with<Z, A, B, C, D, E>(this: new (app: App, a: A, b: B, c: C, d: D, e: E) => Z, a: A, b: B, c: C, d: D, e: E): ServiceConfig;
    // static with<Z, A, B, C, D>(this: new (app: App, a: A, b: B, c: C, d: D) => Z, a: A, b: B, c: C, d: D): ServiceConfig;
    // static with<Z, A, B, C>(this: new (app: App, a: A, b: B, c: C) => Z, a: A, b: B, c: C): ServiceConfig;
    // static with<Z, A, B>(this: new (app: App, a: A, b: B) => Z, a: A, b: B): ServiceConfig;
    // static with<Z, A>(this: new (app: App, a: A) => Z, a: A): ServiceConfig;
    // static with(...a: any[]) {
    Service.initWith = function (config) {
        return new ServiceConfig(this, config);
    };
    /**
     * Overload this method to perform your service initiation. You can
     * return a Promise to indicate that the service may initialize itself
     * asynchronously -- it may for instance perform network requests.
     *
     * If this service used require() for another service, then init() will
     * only be called once the dependencies' init() have been resolved.
     */
    Service.prototype.init = function (a) {
        if (a === void 0) { a = null; }
        return null;
    };
    /**
     *
     */
    Service.prototype.getInitPromise = function (deps) {
        var _this = this;
        var conf = this.app.resolver.configs.get(this.constructor);
        var params = conf ? conf.params : [];
        if (!this._initPromise)
            this._initPromise = Promise.all(deps).then(function () { return _this.init.apply(_this, params); });
        return Promise.resolve(this._initPromise);
    };
    /**
     * Require another service and put it into the list of dependencies.
     */
    Service.prototype.require = function (p) {
        var serv = this.app.require(p);
        this._dependencies.push(serv);
        return serv;
    };
    Service.prototype.observe = function (a, cbk, options) {
        var unreg = domic_1.o.observe(a, cbk, options);
        this.ondestroy.push(unreg);
        return this;
    };
    /**
     * Override this method to tell when this partial needs to be re-inited.
     */
    Service.prototype.needsReinit = function () {
        for (var _i = 0, _a = this._dependencies; _i < _a.length; _i++) {
            var r = _a[_i];
            if (r.needsReinit())
                return true;
        }
        return false;
    };
    Service.prototype.destroy = function () {
        for (var _i = 0, _a = this.ondestroy; _i < _a.length; _i++) {
            var d_2 = _a[_i];
            d_2();
        }
        this.onDestroy();
    };
    /**
     * Called when destroying this Service.
     * It is meant to be overridden.
     */
    Service.prototype.onDestroy = function () {
    };
    return Service;
}());
exports.Service = Service;
/**
 *
 */
var Screen = (function () {
    function Screen(app, name) {
        this.app = app;
        this.name = name;
        this.blocks = new Map();
        this.deps = new Set();
    }
    Screen.prototype.include = function (def) {
        var _this = this;
        def.blocks.forEach(function (view, block) {
            if (!_this.blocks.has(block))
                // include never overwrites blocks we would already have.
                _this.setBlock(block, view);
        });
        return this;
    };
    Screen.prototype.extend = function (name) {
        var views = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            views[_i - 1] = arguments[_i];
        }
        var s = new Screen(this.app, name);
        s.include(this);
        s.define.apply(s, views);
        return s;
    };
    Screen.prototype.define = function () {
        var _this = this;
        var views = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            views[_i] = arguments[_i];
        }
        views.forEach(function (view) { return _this.setBlock(view.block, view); });
        return this;
    };
    Screen.prototype.setBlock = function (block, view) {
        var _this = this;
        this.blocks.set(block, view);
        view.deps.forEach(function (dep) { return _this.deps.add(dep); });
        return this;
    };
    return Screen;
}());
exports.Screen = Screen;
/**
 * A view is a render function with Service dependencies that are resolved
 * every time the application changes Screen.
 */
var View = (function () {
    function View(app) {
        this.app = app;
    }
    return View;
}());
exports.View = View;
/**
 *
 */
var DisplayBlockAtom = (function (_super) {
    __extends(DisplayBlockAtom, _super);
    function DisplayBlockAtom() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = "block " + _this.attrs.block._name;
        return _this;
    }
    DisplayBlockAtom.prototype.render = function () {
        var _this = this;
        this.observe(this.attrs.block.app.o_services, function (services) {
            if (!exports.app.current_screen)
                return;
            _this.update(exports.app);
        });
        return _super.prototype.render.call(this);
    };
    DisplayBlockAtom.prototype.update = function (app) {
        // FIXME : check if the view has had changes in services or if
        // the view object has changed.
        var view = app.current_screen.blocks.get(this.attrs.block);
        if (!view)
            return this.updateChildren(null);
        var deps = view.deps.map(function (type) { return app.services.get(type); });
        var newdeps = new Set(deps);
        var dep_changed = !this.current_deps; // compute if dependency changed.
        if (this.current_deps) {
            for (var _i = 0, deps_1 = deps; _i < deps_1.length; _i++) {
                var d_3 = deps_1[_i];
                if (!this.current_deps.has(d_3)) {
                    dep_changed = true;
                    break;
                }
            }
        }
        if (view === this.current_view && !dep_changed)
            return;
        this.current_view = view;
        this.current_deps = newdeps;
        // Compute the new view value.
        this.updateChildren(view.fn.apply(view, deps));
    };
    return DisplayBlockAtom;
}(domic_1.VirtualHolder));
exports.DisplayBlockAtom = DisplayBlockAtom;
/**
 * Display a Block into the Tree
 */
function DisplayBlock(block) {
    return domic_1.d(DisplayBlockAtom, { block: block });
}
exports.DisplayBlock = DisplayBlock;

},{"domic":5}],3:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var domic_1 = require("domic");
exports.LANG = domic_1.o(navigator.language.slice(0, 2));
function P(n, plural, singular) {
    if (n > 1)
        return plural;
    return singular;
}
exports.P = P;
function S(n) { return P(n, 's', ''); }
exports.S = S;
function L(l) {
    for (var x in l) {
        if (typeof l[x] === 'string') {
            var res = new I18nObservable();
            res.trads = l; // I know what I'm doing !!
            return res;
        }
        else {
            var res2 = new I18nObject();
            res2.trads = l; // here too.
            return res2;
        }
    }
}
exports.L = L;
var I18nObservable = (function (_super) {
    __extends(I18nObservable, _super);
    function I18nObservable() {
        var _this = _super.call(this, exports.LANG, function (lang) {
            if (!this.trads || !this.trads[lang])
                return '';
            return this.trads[lang];
        }, undefined) || this;
        _this.trads = {};
        return _this;
    }
    return I18nObservable;
}(domic_1.TransformObservable));
exports.I18nObservable = I18nObservable;
/**
 *
 */
var I18nObject = (function () {
    function I18nObject() {
        this.trads = {};
    }
    /**
     * Use into the dom.
     * @param ctx
     */
    I18nObject.prototype.use = function (arg) {
        var _this = this;
        return domic_1.Display(domic_1.o.merge({ lang: exports.LANG, arg: arg }).tf(function (val) {
            var res = _this.trads[val.lang](val.arg);
            if (typeof res === 'string')
                return document.createTextNode(res);
            return res;
        }));
    };
    return I18nObject;
}());
exports.I18nObject = I18nObject;

},{"domic":5}],4:[function(require,module,exports){
(function(e, a) { for(var i in a) e[i] = a[i]; }(exports, /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var dialog = __webpack_require__(1);
	exports.dialog = dialog;
	var toast_1 = __webpack_require__(8);
	exports.toast = toast_1.default;
	var button_1 = __webpack_require__(5);
	exports.Button = button_1.Button;
	exports.ButtonBar = button_1.ButtonBar;
	var checkbox_1 = __webpack_require__(9);
	exports.Checkbox = checkbox_1.Checkbox;
	var icon_1 = __webpack_require__(6);
	exports.Icon = icon_1.Icon;
	var input_1 = __webpack_require__(10);
	exports.Input = input_1.Input;
	var radio_1 = __webpack_require__(11);
	exports.Radio = radio_1.Radio;
	var toolbar_1 = __webpack_require__(12);
	exports.Toolbar = toolbar_1.Toolbar;
	var content_1 = __webpack_require__(13);
	exports.Content = content_1.Content;
	var select_1 = __webpack_require__(14);
	exports.Select = select_1.Select;
	var tab_1 = __webpack_require__(15);
	exports.Tab = tab_1.Tab;
	exports.TabContainer = tab_1.TabContainer;
	var flex_1 = __webpack_require__(3);
	exports.Child = flex_1.Child;
	exports.Row = flex_1.Row;
	exports.Column = flex_1.Column;
	var card_1 = __webpack_require__(16);
	exports.Card = card_1.Card;
	var nav_1 = __webpack_require__(17);
	exports.Nav = nav_1.Nav;
	exports.NavHeader = nav_1.NavHeader;
	exports.NavSubheader = nav_1.NavSubheader;
	exports.NavDivider = nav_1.NavDivider;
	exports.NavItem = nav_1.NavItem;
	exports.NavBody = nav_1.NavBody;
	exports.NavFooter = nav_1.NavFooter;
	var animate_1 = __webpack_require__(4);
	exports.animate = animate_1.animate;
	var ink_1 = __webpack_require__(7);
	exports.inkable = ink_1.inkable;
	exports.inkClickDelay = ink_1.inkClickDelay;


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var domic_1 = __webpack_require__(2);
	var flex_1 = __webpack_require__(3);
	var animate_1 = __webpack_require__(4);
	var button_1 = __webpack_require__(5);
	var DialogCtrl = (function (_super) {
	    __extends(DialogCtrl, _super);
	    function DialogCtrl() {
	        var _this = _super.call(this) || this;
	        _this.promise = new Promise(function (resolve, reject) {
	            _this._resolve = resolve;
	            _this._reject = reject;
	        });
	        return _this;
	    }
	    DialogCtrl.prototype.resolve = function (value) {
	        this._resolve(value);
	    };
	    DialogCtrl.prototype.reject = function (value) {
	        this._reject(value);
	    };
	    return DialogCtrl;
	}(domic_1.Controller));
	exports.DialogCtrl = DialogCtrl;
	exports.Overlay = function (attrs, children) {
	    return D(flex_1.Column, { align: 'center', justify: 'center', class: 'dm-dialog-overlay' }, children);
	};
	exports.Title = function (attrs, children) { return D("h3", { class: 'dm-dialog-title' }, children); };
	exports.Content = function (attrs, children) { return D("div", { class: 'dm-dialog-content' }, children); };
	// FIXME this node should watch the width of its children to be able
	// to switch to the vertical presentation for dialog buttons.
	exports.Buttonbar = function (attrs, children) {
	    return D("div", { class: ['dm-dialog-buttonbar', { stacked: attrs.stacked }] }, children);
	};
	exports.Root = function (attrs, children) { return D(flex_1.Column, { class: 'dm-dialog-root' }, children); };
	/**
	 * A function that returns a promise and that allows us to show a nice dialog.
	 */
	function dialog(opts, cbk) {
	    var dlg = new DialogCtrl();
	    var contents = cbk(dlg);
	    function bye(res) {
	        return animate_1.animateClass(dialog_holder, 'animation-leave').then(function () {
	            dialog_holder.remove();
	            return res;
	        });
	    }
	    function handleEscape(ev) {
	        if (opts.noEscapeKey)
	            return;
	        if (ev.keyCode === 27)
	            dlg.reject('pressed escape');
	    }
	    var dialog_holder = D(exports.Overlay, { "$$": [
	            domic_1.click(function (e) {
	                if (e.target === this && opts.clickOutsideToClose)
	                    dlg.reject('clicked outside to close');
	            }),
	            domic_1.ctrl(dlg),
	            // Handle the escape key.
	            domic_1.onmount(function (node) { return node.ownerDocument.addEventListener('keyup', handleEscape); }),
	            domic_1.onunmount(function (node) { return node.ownerDocument.removeEventListener('keyup', handleEscape); })
	        ] },
	        D(exports.Root, { class: opts.class ? opts.class : null }, contents));
	    if (!opts.noanimate) {
	        animate_1.animateClass(dialog_holder, 'animation-enter');
	    }
	    // Remove the dialog from the DOM once we have answered it.
	    var parent = opts.parent || document.body;
	    parent.appendChild(dialog_holder);
	    return dlg.promise.then(bye, function (err) { return bye(Promise.reject(err)); });
	}
	exports.dialog = dialog;
	/**
	 * A modal dialog.
	 * @param  {Object} opts Options
	 * @return {Promise}
	 */
	function modal(opts) {
	    return dialog(opts, function (dlg) {
	        return D(domic_1.Fragment, null,
	            opts.title ? D(exports.Title, null, opts.title) : null,
	            D(exports.Content, null, opts.text.split(/\s*\n\s*/).map(function (e) { return D("p", null, e); })),
	            D(exports.Buttonbar, null,
	                domic_1.DisplayIf(opts.disagree, function (disagree) {
	                    return D(button_1.Button, { click: function () { return dlg.resolve(false); } }, disagree);
	                }),
	                domic_1.DisplayIf(opts.agree, function (agree) {
	                    return D(button_1.Button, { click: function () { return dlg.resolve(true); } }, agree);
	                })));
	    });
	}
	exports.modal = modal;


/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = require("domic");

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var domic_1 = __webpack_require__(2);
	// flex-direction
	// flex-wrap
	// justify-content
	// align-items
	// align-content
	// CHILDREN :
	// order
	// shrink
	// grow
	// basis !
	// align-self
	function _(elt, prop, value) {
	    switch (value) {
	        case 'around':
	            value = 'space-around';
	            break;
	        case 'between':
	            value = 'space-between';
	            break;
	        case 'start':
	            value = 'flex-start';
	            break;
	        case 'end':
	            value = 'flex-end';
	            break;
	        case 'no':
	            value = 'nowrap';
	            break;
	    }
	    var style = elt.style;
	    style[prop] = value;
	    style["webkit" + (prop[0].toUpperCase() + prop.slice(1))] = value;
	}
	function _parse_attributes(el, at) {
	    var cls = el.classList;
	    if (at.wrap != null)
	        cls.add('dm-flex-wrap');
	    if (at.direction != null) {
	        if (!at.reverse)
	            _(el, 'flexDirection', at.direction);
	        else
	            _(el, 'flexDirection', at.direction === 'column' ? 'column-reverse' : 'row-reverse');
	    }
	    else if (at.reverse != null)
	        _(el, 'flexDirection', 'row-reverse');
	    if (at.grow != null)
	        _(el, 'flexGrow', at.grow);
	    if (at.basis != null)
	        _(el, 'flexBasis', at.basis);
	    if (at.absoluteGrow != null) {
	        _(el, 'flexGrow', at.absoluteGrow);
	        _(el, 'flexBasis', '0');
	    }
	    if (at.align != null) {
	        _(el, 'alignItems', at.align);
	    }
	    if (at.justify != null) {
	        _(el, 'justifyContent', at.justify);
	    }
	}
	function Row(at, ch) {
	    var node = domic_1.d('div', { class: 'dm-flex' }, ch);
	    _parse_attributes(node, at);
	    return node;
	}
	exports.Row = Row;
	function Column(at, ch) {
	    at.direction = 'column';
	    var node = domic_1.d('div', { class: 'dm-flex' }, ch);
	    _parse_attributes(node, at);
	    return node;
	}
	exports.Column = Column;
	/**
	 * A child that's not a flex itself (otherwise we'd use Row or Column), on which
	 * there is hence no point in using the special align-items, ...
	 */
	function Child(at, ch) {
	    var node = domic_1.d('div', null, ch);
	    _parse_attributes(node, at);
	    return node;
	}
	exports.Child = Child;


/***/ },
/* 4 */
/***/ function(module, exports) {

	/* Inactive browser tabs pause rAF, which results in all active animations immediately sprinting to their completion states when the tab refocuses.
	     To get around this, we dynamically switch rAF to setTimeout (which the browser *doesn't* pause) when the tab loses focus. We skip this for mobile
	     devices to avoid wasting battery power on inactive tabs. */
	/* Note: Tab focus detection doesn't work on older versions of IE, but that's okay since they don't support rAF to begin with. */
	// if (!Velocity.State.isMobile && document.hidden !== undefined) {
	// 	document.addEventListener("visibilitychange", function() {
	// 		/* Reassign the rAF function (which the global tick() function uses) based on the tab's focus state. */
	// 		if (document.hidden) {
	// 			ticker = function(callback) {
	// 				 // The tick function needs a truthy first argument in order to pass its internal timestamp check.
	// 				return setTimeout(function() { callback(true) }, 16);
	// 			};
	"use strict";
	// 			/* The rAF loop has been paused by the browser, so we manually restart the tick. */
	// 			tick();
	// 		} else {
	// 			ticker = window.requestAnimationFrame || rAFShim;
	// 		}
	// 	});
	// }
	function transition() {
	}
	exports.transition = transition;
	var END_EVENTS = ['webkitAnimationEnd', 'mozAnimationEnd', 'MSAnimationEnd', 'oanimationend', 'animationend'];
	var START_EVENTS = ['webkitAnimationStart', 'mozAnimationStart', 'MSAnimationStart', 'oanimationstart', 'animationstart'];
	function animate(node, anim) {
	    return new Promise(function (resolve, reject) {
	        node.style.animation = anim;
	        var events = ['webkitAnimationEnd', 'mozAnimationEnd', 'MSAnimationEnd', 'oanimationend', 'animationend'];
	        function bye() {
	            events.forEach(function (name) { return node.removeEventListener(name, bye); });
	            resolve(node);
	        }
	        events.forEach(function (name) { return node.addEventListener(name, bye); });
	    });
	}
	exports.animate = animate;
	function animateClass(node, cls) {
	    node.classList.add(cls);
	    return new Promise(function (resolve, reject) {
	        var fnend = function () {
	            anim_end_count += 1;
	            // Remove all the event listeners.
	            if (anim_start_count == anim_end_count) {
	                START_EVENTS.forEach(function (name) { return node.removeEventListener(name, fnstart); });
	                END_EVENTS.forEach(function (name) { return node.removeEventListener(name, fnend); });
	                // setTimeout(() => node.classList.remove(cls), 100)
	                resolve();
	            }
	        };
	        var fnstart = function () {
	            anim_start_count += 1;
	        };
	        var anim_start_count = 0;
	        var anim_end_count = 0;
	        START_EVENTS.forEach(function (name) { return node.addEventListener(name, fnstart); });
	        END_EVENTS.forEach(function (name) { return node.addEventListener(name, fnend); });
	        // We leave 100 ms to the animations to potentially start. If during
	        // this delay nothing started, we call the end function.
	        setTimeout(function () {
	            if (anim_start_count === 0) {
	                anim_end_count -= 1;
	                fnend();
	            }
	        }, 100);
	    });
	}
	exports.animateClass = animateClass;


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var domic_1 = __webpack_require__(2);
	var icon_1 = __webpack_require__(6);
	var flex_1 = __webpack_require__(3);
	var ink_1 = __webpack_require__(7);
	var ButtonBar = (function (_super) {
	    __extends(ButtonBar, _super);
	    function ButtonBar() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    ButtonBar.prototype.addCls = function (node, parent) {
	        parent.classList.add('dm-has-button-bar');
	    };
	    ButtonBar.prototype.removeCls = function (node, parent) {
	        parent.classList.remove('dm-has-button-bar');
	    };
	    ButtonBar.prototype.render = function (children) {
	        return D(flex_1.Row, { class: 'dm-button-bar' }, children);
	    };
	    return ButtonBar;
	}(domic_1.Component));
	__decorate([
	    domic_1.onmount
	], ButtonBar.prototype, "addCls", null);
	__decorate([
	    domic_1.onunmount
	], ButtonBar.prototype, "removeCls", null);
	exports.ButtonBar = ButtonBar;
	function Button(attrs, children) {
	    function doClick(event) {
	        var click = domic_1.o.get(attrs.click);
	        if (!domic_1.o.get(attrs.disabled)) {
	            // in this context, this is the Node.
	            ink_1.inker(event.target, event);
	            click && click.call(this, event);
	        }
	    }
	    // we put it outside since children should be called only once, which
	    // would not happen inside a DisplayUnless.
	    var txt_button = D("span", { class: ['dm-button-content', { disabled: attrs.disabled, raised: attrs.raised }] }, children);
	    return D("button", { class: 'dm-button', disabled: domic_1.o(attrs.disabled).tf(function (val) { return val ? val : undefined; }), "$$": [domic_1.clickfix, domic_1.click(doClick)] }, domic_1.DisplayIf(attrs.icon, function (name) { return D(icon_1.Icon, { class: ['dm-button-icon', { disabled: attrs.disabled, raised: attrs.raised }], name: name }); }, function () { return txt_button; }));
	}
	exports.Button = Button;


/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var domic_1 = __webpack_require__(2);
	function Icon(_a, content) {
	    var name = _a.name;
	    return domic_1.d('i', {
	        'class': ['zmdi', domic_1.o(name).tf(function (name) { return "zmdi-" + (name || 'help-outline'); })]
	    });
	}
	exports.Icon = Icon;


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var domic_1 = __webpack_require__(2);
	function inker(node, event) {
	    var clientX = event.pageX;
	    var clientY = event.pageY;
	    var inker = domic_1.d('div', { class: 'dm-ink' });
	    var ink_container = domic_1.d('div', { class: 'dm-ink-container' }, inker);
	    node.appendChild(ink_container);
	    // atom.append(inker)
	    requestAnimationFrame(function (e) {
	        var bb = ink_container.getBoundingClientRect();
	        inker.style.top = clientY - bb.top + "px";
	        inker.style.left = clientX - bb.left + "px";
	        inker.classList.add('animate');
	        ink_container.classList.add('animate');
	        setTimeout(function () { return ink_container.remove(); }, 1000);
	    });
	    // var bb = atom.element.getBounding
	}
	exports.inker = inker;
	function inkable(node) {
	    return domic_1.click(function (ev) {
	        inker(node, ev);
	    })(node);
	}
	exports.inkable = inkable;
	function inkClickDelay(fn) {
	    return function (node) {
	        return domic_1.click(function (ev) {
	            inker(node, ev);
	            setTimeout(function () { return fn(ev); }, 150);
	        })(node);
	    };
	}
	exports.inkClickDelay = inkClickDelay;


/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var animate_1 = __webpack_require__(4);
	/**
	 * FIXME: there should be a queue instead of brutally dismissing everything.
	 */
	var Toaster = (function () {
	    function Toaster() {
	        this._mounted = false;
	        this._holder = D("div", { class: 'dm--toast-holder' });
	    }
	    Toaster.prototype.kill = function (node) {
	        animate_1.animate(node, 'dm-fade-out 0.2s ease-out both').then(function (node) {
	            return node.remove();
	        });
	    };
	    Toaster.prototype.toast = function (msg) {
	        // if (!this._mounted)
	        // 	this.mount(document.body);
	        var _this = this;
	        if (this._current) {
	            clearTimeout(this._cancel);
	            this.kill(this._current);
	        }
	        // let promise: Promise<any> = this._current ? this._current.destroy() : Promise.resolve(true)
	        if (!this._holder.parentNode)
	            document.body.appendChild(this._holder);
	        var toast = (msg instanceof Node ? msg
	            : D("div", { class: 'dm--toast' }, msg));
	        animate_1.animate(toast, 'dm-fade-in 0.2s ease-in both');
	        this._holder.appendChild(toast);
	        this._cancel = setTimeout(function () { return _this.kill(toast); }, 3000);
	        this._current = toast;
	    };
	    return Toaster;
	}());
	exports.Toaster = Toaster;
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = new Toaster;


/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var domic_1 = __webpack_require__(2);
	var flex_1 = __webpack_require__(3);
	var icon_1 = __webpack_require__(6);
	var ink_1 = __webpack_require__(7);
	var OFF = 'square-o';
	var ON = 'check-square';
	var INDETERMINATE = 'minus-square';
	var Checkbox = (function (_super) {
	    __extends(Checkbox, _super);
	    function Checkbox() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.o_model = domic_1.o(_this.attrs.model);
	        _this.o_disabled = domic_1.o(_this.attrs.disabled);
	        return _this;
	    }
	    Checkbox.prototype.toggle = function () {
	        if (this.o_disabled.get())
	            return;
	        this.o_model.toggle();
	    };
	    Checkbox.prototype.render = function (children) {
	        var _this = this;
	        function getIcon(value) {
	            if (value === undefined)
	                return INDETERMINATE;
	            if (value)
	                return ON;
	            return OFF;
	        }
	        var classes = {
	            on: this.o_model,
	            off: this.o_model.isFalse(),
	            disabled: this.o_disabled
	        };
	        return D("label", { class: 'dm-checkbox-label', "$$": [ink_1.inkable, domic_1.clickfix, domic_1.click(function (e) { return _this.toggle(); })] },
	            D(flex_1.Row, { class: 'dm-checkbox-row', align: 'center' },
	                D(icon_1.Icon, { class: ['dm-checkbox-icon', classes], name: this.o_model.tf(getIcon) }),
	                D("span", { class: ['dm-checkbox-content', classes] }, children)));
	    };
	    return Checkbox;
	}(domic_1.Component));
	exports.Checkbox = Checkbox;


/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __assign = (this && this.__assign) || Object.assign || function(t) {
	    for (var s, i = 1, n = arguments.length; i < n; i++) {
	        s = arguments[i];
	        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
	            t[p] = s[p];
	    }
	    return t;
	};
	var domic_1 = __webpack_require__(2);
	var id_gen = 0;
	function Input(attrs, content) {
	    // Used in validation ???
	    // this.valid = true;
	    var id = attrs.id || "input_" + id_gen++;
	    var data = {
	        model: domic_1.o(attrs.model || ''),
	        type: attrs.type || 'text',
	        label: attrs.label || attrs.placeholder || false,
	        error: domic_1.o(attrs.error),
	        disabled: domic_1.o(attrs.disabled).tf(function (v) { return v ? 'disabled' : undefined; })
	    };
	    var other_attrs = {
	        autofocus: attrs.autofocus,
	        autocapitalize: attrs.autocapitalize,
	        spellcheck: attrs.spellcheck,
	        autocorrect: attrs.autocorrect,
	        autocomplete: attrs.autocomplete
	    };
	    var o_focused = domic_1.o(false);
	    var input = D("input", __assign({ id: id, class: 'dm-input-element', disabled: data.disabled, type: data.type, "$$": [domic_1.bind(data.model), domic_1.click(function (e) {
	                this.focus();
	            })] }, other_attrs));
	    input.addEventListener('blur', function (ev) {
	        o_focused.set(false);
	    });
	    input.addEventListener('focus', function (ev) {
	        o_focused.set(true);
	    });
	    // const o_unfocus_and_empty = o(data.model, o_focused, (value: string, focused: boolean) => !focused && !value)
	    var o_unfocus_and_empty = domic_1.o.merge({ model: data.model, focus: o_focused })
	        .tf(function (value) {
	        var res = !value.model && !value.focus;
	        return res;
	    });
	    return D("div", { class: ['dm-input-container', {
	                focused: o_focused,
	                empty_unfocused: o_unfocus_and_empty,
	                error: attrs.error
	            }] },
	        input,
	        data.label ?
	            D("label", { for: id, class: 'dm-input-floating-label' }, data.label)
	            : null,
	        domic_1.DisplayIf(data.error, function (error) { return D("div", { class: 'dm--input--error' }, error); }));
	}
	exports.Input = Input;


/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var domic_1 = __webpack_require__(2);
	var flex_1 = __webpack_require__(3);
	var icon_1 = __webpack_require__(6);
	var ink_1 = __webpack_require__(7);
	var CHECKED = 'dot-circle';
	var UNCHECKED = 'circle-o';
	var Radio = (function (_super) {
	    __extends(Radio, _super);
	    function Radio(attrs) {
	        var _this = _super.call(this, attrs) || this;
	        _this.disabled = domic_1.o(attrs.disabled || false);
	        _this.value = attrs.value;
	        _this.model = domic_1.o(attrs.model);
	        return _this;
	    }
	    Radio.prototype.setValue = function () {
	        this.model.set(this.value);
	    };
	    Radio.prototype.render = function (children) {
	        var _this = this;
	        var classes = {
	            on: this.model.eq(this.value),
	            off: this.model.ne(this.value),
	            disabled: this.disabled
	        };
	        return D("label", { class: 'dm-checkbox-label', "$$": [ink_1.inkable, domic_1.clickfix, domic_1.click(function (e) { return _this.setValue(); })] },
	            D(flex_1.Row, { align: 'center' },
	                D(icon_1.Icon, { class: ['dm-checkbox-icon', classes], name: this.model.tf(function (m) { return m === _this.value ? CHECKED : UNCHECKED; }) }),
	                D("span", { class: ['dm-checkbox-content', classes] }, children)));
	    };
	    return Radio;
	}(domic_1.Component));
	exports.Radio = Radio;


/***/ },
/* 12 */
/***/ function(module, exports) {

	"use strict";
	function Toolbar(attrs, children) {
	    return D("div", { class: 'dm-toolbar' }, children);
	}
	exports.Toolbar = Toolbar;


/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __assign = (this && this.__assign) || Object.assign || function(t) {
	    for (var s, i = 1, n = arguments.length; i < n; i++) {
	        s = arguments[i];
	        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
	            t[p] = s[p];
	    }
	    return t;
	};
	var flex_1 = __webpack_require__(3);
	function Content(attrs, children) {
	    return D(flex_1.Child, __assign({}, attrs, { class: 'dm-content' }), children);
	}
	exports.Content = Content;


/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	//////////////////////////////////////////////////////////////
	var domic_1 = __webpack_require__(2);
	var Select = (function (_super) {
	    __extends(Select, _super);
	    function Select() {
	        // FIXME attrs handling is probably not wonderful.
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        // model: Observable<T>
	        // options: Observable<T[]>
	        // labelfn: LabelFn<T>
	        // onchange: ChangeFn<T>
	        _this.selected = domic_1.o('-1');
	        return _this;
	    }
	    /**
	     * Setup the observation logic.
	     */
	    Select.prototype.render = function (children) {
	        var _this = this;
	        var mod = false;
	        var attrs = this.attrs;
	        var options = domic_1.o(attrs.options);
	        var model = attrs.model, labelfn = attrs.labelfn, onchange = attrs.onchange;
	        // Used for typing, to avoid the undefined part.
	        var real_labelfn = function (obj) { return obj.label || obj.text || obj; };
	        if (labelfn)
	            real_labelfn = labelfn;
	        //  We use a touched() function to avoid infinite loops since there
	        //  is a circular logic here.
	        var touched = function () {
	            if (mod)
	                return true;
	            mod = true;
	            requestAnimationFrame(function () { mod = false; });
	            return false;
	        };
	        this.observe(options, function (opts) {
	            if (touched())
	                return;
	            _this.selected.set('' + opts.indexOf(model.get()));
	        });
	        this.observe(model, function (v) {
	            if (touched())
	                return;
	            _this.selected.set('' + options.get().indexOf(v));
	        });
	        this.observe(this.selected, function (v) {
	            if (touched())
	                return;
	            model.set(options.get()[parseInt(v)]);
	        });
	        ////////////////////////////////
	        var decorators = [domic_1.clickfix, domic_1.bind(this.selected)];
	        if (onchange) {
	            var fn = onchange; // used this for typing matters.
	            decorators.push(function (node) { return node.addEventListener('change', function (ev) { return fn(model.get(), ev); }); });
	        }
	        return D("label", { class: 'dm-select-label' },
	            D("select", { class: 'dm-select', "$$": decorators }, domic_1.RepeatObservable(options, function (opt, i) { return D("option", { value: i, selected: domic_1.o.merge({ model: model, opt: opt })
	                    .tf(function (val) { return val.model === val.opt ? true : undefined; }) }, opt.tf(real_labelfn)); })));
	    };
	    return Select;
	}(domic_1.Component));
	exports.Select = Select;


/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var __assign = (this && this.__assign) || Object.assign || function(t) {
	    for (var s, i = 1, n = arguments.length; i < n; i++) {
	        s = arguments[i];
	        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
	            t[p] = s[p];
	    }
	    return t;
	};
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var domic_1 = __webpack_require__(2);
	var ink_1 = __webpack_require__(7);
	var flex_1 = __webpack_require__(3);
	var TabContainer = (function (_super) {
	    __extends(TabContainer, _super);
	    function TabContainer() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.o_content = domic_1.o(null);
	        _this.o_active_tab = domic_1.o(null);
	        return _this;
	    }
	    TabContainer.prototype.render = function (children) {
	        return D(flex_1.Column, __assign({}, this.attrs),
	            D(flex_1.Row, { justify: 'center', class: 'dm-tab-bar' }, children),
	            D(flex_1.Column, { absoluteGrow: '1', class: 'dm-tab-content' }, domic_1.Display(this.o_content)));
	    };
	    return TabContainer;
	}(domic_1.Component));
	exports.TabContainer = TabContainer;
	var TabContents = (function (_super) {
	    __extends(TabContents, _super);
	    function TabContents() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.name = 'tab contents';
	        return _this;
	    }
	    return TabContents;
	}(domic_1.VirtualHolder));
	exports.TabContents = TabContents;
	/**
	 * FIXME missing is_active logic, since I don't know how to dynamically
	 * watch the parent container observable.
	 */
	var Tab = (function (_super) {
	    __extends(Tab, _super);
	    function Tab() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.o_is_active = domic_1.o(false);
	        _this.children = [];
	        return _this;
	    }
	    Tab.prototype.linkToTabs = function (node) {
	        var _this = this;
	        this.container = TabContainer.get(node);
	        if (!this.container)
	            throw new Error('Tab must be inside a TabContainer');
	        this.observe(this.container.o_active_tab, function (tab) {
	            _this.o_is_active.set(tab === _this);
	        });
	        // This this tab as the active one if no tab is being displayed
	        if (this.container.o_active_tab.get() == null)
	            this.activate();
	    };
	    Tab.prototype.activate = function () {
	        if (!this.container)
	            throw new Error('No container');
	        if (this.container.o_active_tab.get() === this)
	            return;
	        this.container.o_active_tab.set(this);
	        this.container.o_content.set(domic_1.getDocumentFragment(this.children));
	    };
	    Tab.prototype.render = function (children) {
	        var _this = this;
	        this.children = domic_1.getChildren(children);
	        return D("div", { class: ['dm-tab-title', { active: this.o_is_active }], "$$": [
	                domic_1.click(function (ev) { return _this.activate(); }),
	                ink_1.inkable
	            ] }, this.attrs.title);
	    };
	    return Tab;
	}(domic_1.Component));
	__decorate([
	    domic_1.onfirstmount
	], Tab.prototype, "linkToTabs", null);
	exports.Tab = Tab;


/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __assign = (this && this.__assign) || Object.assign || function(t) {
	    for (var s, i = 1, n = arguments.length; i < n; i++) {
	        s = arguments[i];
	        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
	            t[p] = s[p];
	    }
	    return t;
	};
	var flex_1 = __webpack_require__(3);
	function Card(attrs, children) {
	    return D(flex_1.Column, __assign({ class: 'dm-card-frame' }, attrs), children);
	}
	exports.Card = Card;


/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var domic_1 = __webpack_require__(2);
	var ink_1 = __webpack_require__(7);
	var icon_1 = __webpack_require__(6);
	var flex_1 = __webpack_require__(3);
	var animate_1 = __webpack_require__(4);
	var Nav = (function (_super) {
	    __extends(Nav, _super);
	    function Nav() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    Nav.prototype.detach = function () {
	        var _this = this;
	        animate_1.animateClass(this.node, 'animation-leave').then(function () {
	            _this.node.remove();
	        });
	    };
	    Nav.prototype.show = function () {
	        animate_1.animateClass(this.node, 'animation-enter');
	        document.body.appendChild(this.node);
	    };
	    Nav.prototype.render = function (ch) {
	        var _this = this;
	        var overlay = D("div", { class: 'dm-navigation-overlay', "$$": [domic_1.clickfix, domic_1.click(function (e) {
	                    if (e.target === overlay)
	                        _this.detach();
	                })] });
	        return D("div", { class: 'dm-nav-holder' },
	            overlay,
	            D(flex_1.Column, { class: 'dm-navigation-drawer' }, ch));
	    };
	    return Nav;
	}(domic_1.HTMLComponent));
	exports.Nav = Nav;
	function NavHeader(a, ch) {
	    return D("div", { class: 'dm-navigation-header' }, ch);
	}
	exports.NavHeader = NavHeader;
	function NavSubheader(a, ch) {
	    return D("div", { class: 'dm-navigation-subheader' }, ch);
	}
	exports.NavSubheader = NavSubheader;
	function NavDivider(a, ch) {
	    return D("div", { class: 'dm-navigation-divider' });
	}
	exports.NavDivider = NavDivider;
	function NavItem(a, ch) {
	    var res = D("div", { class: 'dm-navigation-item', "$$": [domic_1.clickfix, ink_1.inkClickDelay(function (e) {
	                if (a.click && a.click(e) !== false) {
	                    var c = Nav.get(res);
	                    // XXX should we log an error here if c was null ?
	                    if (c)
	                        c.detach();
	                }
	            })] },
	        D(icon_1.Icon, { class: 'dm-navigation-item-icon', name: a.icon }),
	        ch);
	    return res;
	}
	exports.NavItem = NavItem;
	function NavBody(a, ch) {
	    return D("div", { class: 'dm-navigation-body' }, ch);
	}
	exports.NavBody = NavBody;
	function NavFooter(a, ch) {
	    return D("div", { class: 'dm-navigation-footer' }, ch);
	}
	exports.NavFooter = NavFooter;


/***/ }
/******/ ])));

},{"domic":5}],5:[function(require,module,exports){
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["domic"] = factory();
	else
		root["domic"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	function __export(m) {
	    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
	}
	var domic_1 = __webpack_require__(1);
	exports.getDocumentFragment = domic_1.getDocumentFragment;
	exports.getChildren = domic_1.getChildren;
	exports.d = domic_1.d;
	var mounting_1 = __webpack_require__(6);
	exports.setupMounting = mounting_1.setupMounting;
	var decorators_1 = __webpack_require__(5);
	exports.bind = decorators_1.bind;
	exports.BindController = decorators_1.BindController;
	exports.click = decorators_1.click;
	exports.clickfix = decorators_1.clickfix;
	exports.focusOnMount = decorators_1.focusOnMount;
	exports.observe = decorators_1.observe;
	exports.onmount = decorators_1.onmount;
	exports.onfirstmount = decorators_1.onfirstmount;
	exports.onrender = decorators_1.onrender;
	exports.onunmount = decorators_1.onunmount;
	exports.on = decorators_1.on;
	exports.scrollable = decorators_1.scrollable;
	var controller_1 = __webpack_require__(3);
	exports.Component = controller_1.Component;
	exports.Controller = controller_1.Controller;
	exports.ctrl = controller_1.ctrl;
	exports.HTMLComponent = controller_1.HTMLComponent;
	__export(__webpack_require__(2));
	var verbs_1 = __webpack_require__(4);
	exports.Display = verbs_1.Display;
	exports.DisplayIf = verbs_1.DisplayIf;
	exports.DisplayUnless = verbs_1.DisplayUnless;
	exports.Fragment = verbs_1.Fragment;
	exports.Repeat = verbs_1.Repeat;
	exports.RepeatObservable = verbs_1.RepeatObservable;
	exports.RepeatScroll = verbs_1.RepeatScroll;
	exports.RepeatScrollObservable = verbs_1.RepeatScrollObservable;
	exports.Repeater = verbs_1.Repeater;
	exports.VirtualHolder = verbs_1.VirtualHolder;
	exports.Write = verbs_1.Write;
	exports.Writer = verbs_1.Writer;


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var domic_observable_1 = __webpack_require__(2);
	var controller_1 = __webpack_require__(3);
	var verbs_1 = __webpack_require__(4);
	function _apply_class(node, c) {
	    if (!c)
	        return;
	    c.split(/\s+/g).forEach(function (c) { return node.classList.add(c); });
	}
	function _remove_class(node, c) {
	    if (!c)
	        return;
	    c.split(/\s+/g).forEach(function (c) { return node.classList.remove(c); });
	}
	/**
	 *
	 */
	function applyClass(node, c, ct) {
	    if (typeof c === 'string') {
	        _apply_class(node, c);
	    }
	    else if (c instanceof domic_observable_1.Observable) {
	        if (!ct)
	            ct = new controller_1.DefaultController();
	        var old_class_1 = null;
	        ct.observe(c, function (str) {
	            if (old_class_1)
	                _remove_class(node, old_class_1);
	            _apply_class(node, str);
	            old_class_1 = str;
	        });
	    }
	    else {
	        var _loop_1 = function (x) {
	            if (c[x] instanceof domic_observable_1.Observable) {
	                if (!ct)
	                    ct = new controller_1.DefaultController();
	                ct.observe(c[x], function (applied) {
	                    applied ? _apply_class(node, x) : _remove_class(node, x);
	                });
	            }
	            else {
	                if (c[x])
	                    _apply_class(node, x);
	            }
	        };
	        // c is an object
	        for (var x in c) {
	            _loop_1(x);
	        }
	    }
	    return ct;
	}
	function applyStyle(node, c, ct) {
	    if (typeof c === 'string') {
	        node.setAttribute('style', c);
	    }
	    else if (c instanceof domic_observable_1.Observable) {
	        if (!ct)
	            ct = new controller_1.DefaultController();
	        ct.observe(c, function (str) {
	            node.setAttribute('style', str);
	        });
	    }
	    else {
	        var _loop_2 = function (x) {
	            if (c[x] instanceof domic_observable_1.Observable) {
	                if (!ct)
	                    ct = new controller_1.DefaultController();
	                ct.observe(c[x], function (value) {
	                    node.style[x] = value;
	                });
	            }
	            else {
	                if (c[x])
	                    node.style[x] = c[x];
	            }
	        };
	        // c is an object
	        for (var x in c) {
	            _loop_2(x);
	        }
	    }
	    return ct;
	}
	/**
	 * Apply attribute to the node
	 */
	function applyAttribute(node, name, value, ct) {
	    if (value instanceof domic_observable_1.Observable) {
	        if (!ct)
	            ct = new controller_1.DefaultController();
	        ct.observe(value, function (val) {
	            if (val != null)
	                node.setAttribute(name, val);
	            else {
	                node.removeAttribute(name);
	            }
	        });
	    }
	    else {
	        if (value != null)
	            node.setAttribute(name, value);
	    }
	    return ct;
	}
	/**
	 *
	 */
	function getDocumentFragment(children) {
	    var result = document.createDocumentFragment();
	    _foreach(children, function (c) {
	        // Do not do anything with null
	        if (c == null)
	            return;
	        if (Array.isArray(c)) {
	            result.appendChild(getDocumentFragment(c));
	        }
	        else if (c instanceof domic_observable_1.Observable) {
	            result.appendChild(verbs_1.Write(c));
	        }
	        else if (!(c instanceof Node)) {
	            result.appendChild(document.createTextNode(c.toString()));
	        }
	        else {
	            result.appendChild(c);
	        }
	    });
	    return result;
	}
	exports.getDocumentFragment = getDocumentFragment;
	function getChildren(node) {
	    var result = [];
	    var iter = node.firstChild;
	    while (iter) {
	        result.push(iter);
	        iter = iter.nextSibling;
	    }
	    return result;
	}
	exports.getChildren = getChildren;
	/**
	 * Apply a function to each element of the provided array if
	 * it is an array or to the single element if it was not.
	 *
	 * Does nothing if null was supplied.
	 */
	function _foreach(maybe_array, fn) {
	    if (!maybe_array)
	        return;
	    if (Array.isArray(maybe_array)) {
	        for (var _i = 0, maybe_array_1 = maybe_array; _i < maybe_array_1.length; _i++) {
	            var e = maybe_array_1[_i];
	            fn(e);
	        }
	    }
	    else {
	        fn(maybe_array);
	    }
	}
	exports._foreach = _foreach;
	var SVG = "http://www.w3.org/2000/svg";
	var NS = {
	    // SVG nodes, shamelessly stolen from React.
	    svg: SVG,
	    circle: SVG,
	    clipPath: SVG,
	    defs: SVG,
	    desc: SVG,
	    ellipse: SVG,
	    feBlend: SVG,
	    feColorMatrix: SVG,
	    feComponentTransfer: SVG,
	    feComposite: SVG,
	    feConvolveMatrix: SVG,
	    feDiffuseLighting: SVG,
	    feDisplacementMap: SVG,
	    feDistantLight: SVG,
	    feFlood: SVG,
	    feFuncA: SVG,
	    feFuncB: SVG,
	    feFuncG: SVG,
	    feFuncR: SVG,
	    feGaussianBlur: SVG,
	    feImage: SVG,
	    feMerge: SVG,
	    feMergeNode: SVG,
	    feMorphology: SVG,
	    feOffset: SVG,
	    fePointLight: SVG,
	    feSpecularLighting: SVG,
	    feSpotLight: SVG,
	    feTile: SVG,
	    feTurbulence: SVG,
	    filter: SVG,
	    foreignObject: SVG,
	    g: SVG,
	    image: SVG,
	    line: SVG,
	    linearGradient: SVG,
	    marker: SVG,
	    mask: SVG,
	    metadata: SVG,
	    path: SVG,
	    pattern: SVG,
	    polygon: SVG,
	    polyline: SVG,
	    radialGradient: SVG,
	    rect: SVG,
	    stop: SVG,
	    switch: SVG,
	    symbol: SVG,
	    text: SVG,
	    textPath: SVG,
	    tspan: SVG,
	    use: SVG,
	    view: SVG,
	};
	function d(elt, attrs) {
	    var children = [];
	    for (var _i = 2; _i < arguments.length; _i++) {
	        children[_i - 2] = arguments[_i];
	    }
	    if (!elt)
	        throw new Error("d() needs at least a string, a function or a Component");
	    var node = null;
	    // Classes and style are applied at the end of this function and are thus
	    // never passed to other node definitions.
	    var ct = null;
	    var decorators;
	    var style;
	    var cls;
	    if (attrs) {
	        decorators = attrs.$$;
	        style = attrs.style;
	        cls = attrs.class;
	        if (cls)
	            delete attrs.class;
	        if (style)
	            delete attrs.style;
	        if (decorators)
	            delete attrs.$$;
	    }
	    else {
	        attrs = {};
	    }
	    if (typeof elt === 'string') {
	        var ns = NS[elt] || attrs.xmlns;
	        node = ns ? document.createElementNS(ns, elt) : document.createElement(elt);
	        for (var x in attrs) {
	            ct = applyAttribute(node, x, attrs[x], ct);
	        }
	        // Append children to the node.
	        if (children) {
	            node.appendChild(getDocumentFragment(children));
	        }
	    }
	    else if (typeof elt === 'function' && elt.prototype.render) {
	        // elt is an instantiator / Component
	        var kls = elt;
	        var comp = new kls(attrs);
	        node = comp.render(getDocumentFragment(children));
	        comp.bindToNode(node);
	    }
	    else if (typeof elt === 'function') {
	        // elt is just a creator function
	        node = elt(attrs, getDocumentFragment(children));
	    }
	    var defined_node = node;
	    // decorators are run now. If class and style were defined, they will be applied to the
	    // final node.
	    _foreach(decorators, function (dec) { return dec(defined_node); });
	    // Class attributes and Style attributes are special and forwarded accross nodes and are thus
	    // always added (unlike other attributes which are simply passed forward)
	    _foreach(cls, function (cl) {
	        ct = applyClass(node, cl, ct);
	    });
	    _foreach(style, function (st) {
	        ct = applyStyle(node, st, ct);
	    });
	    if (ct)
	        ct.bindToNode(defined_node);
	    // Call onrender on component now that all the linking is done.
	    _foreach(controller_1.Controller.all(defined_node), function (ctrl) { return ctrl.onrender.forEach(function (r) { return r.call(ctrl, node); }); });
	    return defined_node;
	}
	exports.d = d;
	if (typeof window !== 'undefined' && typeof window.D === 'undefined') {
	    window.D = d;
	}


/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////// CLASS DEFINITIONS //////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////
	var BASE_OBJECT_ONLY = Symbol('base');
	var ALL_PROPERTIES = Symbol('all_props');
	function debounce(fn, ms) {
	    var timeout = null;
	    return function () {
	        var a = [];
	        for (var _i = 0; _i < arguments.length; _i++) {
	            a[_i] = arguments[_i];
	        }
	        var self = this;
	        if (timeout != null)
	            clearTimeout(timeout);
	        timeout = setTimeout(function () {
	            timeout = null;
	            fn.apply(self, a);
	        }, ms);
	    };
	}
	function throttle(func, wait) {
	    return func;
	}
	function changeOnly(func) {
	    var old_value;
	    return function (value) {
	        if (value !== old_value)
	            func.apply(void 0, Array.prototype.slice.call(arguments));
	        old_value = value;
	    };
	}
	// Several possibilities ;
	// 1. The object changed completely
	// 2. The object itself didn't change, but one or several properties have
	// 3. The object hasn't changed but it's the first time we listen to it (is it a real case ?)
	var Change = (function () {
	    function Change() {
	        // there is no way for now to distinguish between arrays
	        // and regular objects, so we just wrap it with any.
	        this._props = null;
	    }
	    Change.create = function (new_value, old_value) {
	        var chg = new Change();
	        chg.new_value = new_value;
	        chg.old_value = old_value;
	        return chg;
	    };
	    Change.noop = function (val) {
	        var chg = new Change();
	        chg.new_value = val;
	        return chg;
	    };
	    Change.prototype.set = function (p, changes) {
	        if (!this._props)
	            this._props = {};
	        this._props[p] = changes;
	        return this;
	    };
	    Change.prototype.valueChanged = function () {
	        return this.new_value !== this.old_value && typeof this.old_value !== undefined;
	    };
	    Change.prototype.props = function () {
	        return this._props;
	    };
	    Change.prototype.merge = function (changes) {
	        // Changes that are to be merged can be either a set of subchanges
	        // or a main change, or simply nothing.
	        if (typeof changes === 'undefined')
	            return this;
	        if (typeof changes.new_value !== 'undefined')
	            this.new_value = changes.new_value;
	        // Do not import subvalues, and remove the ones we had.
	        if (this.new_value !== this.old_value) {
	            this._props = null;
	            return this;
	        }
	        for (var x in changes._props) {
	            if (!this._props)
	                this._props = {};
	            if (!this._props[x])
	                this._props[x] = changes._props[x];
	            else
	                this._props[x].merge(changes._props[x]);
	        }
	        return this;
	    };
	    Change.prototype.p = function (p) {
	        return this._props ? this._props[p] : undefined;
	    };
	    return Change;
	}());
	exports.Change = Change;
	// Internal
	var C = Change;
	/**
	 *
	 */
	var Observable = (function () {
	    function Observable(value) {
	        this._observers_count = 0;
	        this._changes = null;
	        this._value = value;
	        this._observers = {};
	    }
	    /**
	     * Pause notifications. Use it when you're about to make many changes
	     * to this observable but don't want the observers to trigger immediately.
	     *
	     * If the observable was already pausing its notifications, do nothing.
	     */
	    Observable.prototype.pauseObserving = function () {
	        if (this._changes !== null)
	            return;
	        this._changes = C.create(this._value, this._value);
	    };
	    /**
	     * Notify the observers with the changes.
	     */
	    Observable.prototype.resumeObserving = function () {
	        // notify
	        if (this._changes === null)
	            return;
	        var chg = this._changes;
	        this._changes = null;
	        this.notify(chg);
	    };
	    Observable.prototype.isPaused = function () {
	        return this._changes !== null;
	    };
	    Observable.prototype.isBeingObserved = function () {
	        return this._observers_count > 0;
	    };
	    Observable.prototype.get = function (p) {
	        if (p == null || p === '')
	            return this._value;
	        return (this._value == null ? {} : this._value)[p];
	    };
	    Observable.prototype.set = function (prop, value) {
	        var changed = false;
	        var val = this._value;
	        var old_value = this._value;
	        if (typeof value !== 'undefined') {
	            var old_prop = val[prop];
	            val[prop] = value;
	            changed = old_prop !== value;
	            if (changed) {
	                var chg = C.noop(this._value)
	                    .set(prop, C.create(val[prop], old_prop));
	                this.notify(chg);
	            }
	        }
	        else {
	            value = prop;
	            changed = this._value !== value;
	            this._value = value;
	            if (changed) {
	                this.notify(C.create(this._value, old_value));
	            }
	        }
	        return changed;
	    };
	    /**
	     * Notify the observers of changes. If the observable is paused, then
	     * stash the changes until it will be able to send it to the subscribers.
	     *
	     * @param changes: a list of changes to merge to our current changes.
	     */
	    Observable.prototype.notify = function (changes_arg) {
	        var changes = changes_arg || C.noop(this._value);
	        if (this._changes) {
	            this._changes.merge(changes_arg);
	            return;
	        }
	        var obss = this._observers;
	        var x;
	        if (obss[ALL_PROPERTIES]) {
	            obss[ALL_PROPERTIES].forEach(function (ob) { return ob(changes.new_value, changes); });
	        }
	        var props = changes.props();
	        if (props === null && changes.valueChanged() && obss[BASE_OBJECT_ONLY]) {
	            obss[BASE_OBJECT_ONLY].forEach(function (ob) { return ob(changes.new_value, changes); });
	        }
	        if (props) {
	            for (x in props) {
	                // Call all the observers...
	                if (obss[x] == null)
	                    continue;
	                var subchanges = props[x];
	                obss[x].forEach(function (ob) { return ob(subchanges.new_value, subchanges); });
	            }
	        }
	        // If there was a change and no sub-property defined, then
	        // simply call everyone.
	        if (props === null) {
	            var y;
	            for (y in obss) {
	                var val = this._value != null ? this._value[y] : undefined;
	                // send a fake C.create
	                obss[y].forEach(function (ob) { return ob(val, C.create(val)); });
	            }
	        }
	    };
	    Observable.prototype.addObserver = function (fn, options, prop) {
	        var _this = this;
	        options = options || {};
	        var path = (prop != null ? prop :
	            options && options.ignoreChildren ? BASE_OBJECT_ONLY : ALL_PROPERTIES);
	        var oba = this._observers;
	        if (!oba[path])
	            oba[path] = [];
	        this._observers_count++;
	        if (options.debounce) {
	            fn = debounce(fn, options.debounce);
	        }
	        if (options.throttle) {
	            fn = throttle(fn, options.throttle);
	        }
	        if (options.changesOnly) {
	            fn = changeOnly(fn);
	        }
	        if (!options.updatesOnly) {
	            var value = this._value;
	            if (prop != null) {
	                var subval = value == null ? undefined : value[prop];
	                fn(subval, C.create(subval));
	            }
	            else {
	                fn(value, C.create(value));
	            }
	        }
	        oba[path].push(fn);
	        return function () {
	            _this.removeObserver(fn, path);
	        };
	    };
	    /**
	     * Remove an observer function from this observable.
	     */
	    Observable.prototype.removeObserver = function (fn, path) {
	        var obs_array = this._observers[path];
	        var index = obs_array ? obs_array.indexOf(fn) : -1;
	        if (index > -1) {
	            obs_array.splice(index, 1);
	            this._observers_count--;
	        }
	    };
	    Observable.prototype.prop = function (prop) {
	        // we cheat here.
	        return new PropObservable(this, prop);
	    };
	    Observable.prototype.p = function (prop) {
	        return this.prop(prop);
	    };
	    // tf<U>(transformer: Transformer<T, U> | TransformFn<T, U>) : TransformObservable<T, U> {
	    //   if (typeof transformer === 'function') {
	    //     return new TransformObservable<T, U>(this, {transform: transformer as TransformFn<T, U>})
	    //   }
	    //   return new TransformObservable<T, U>(this, transformer as Transformer<T, U>)
	    // }
	    Observable.prototype.tf = function (transform, revert) {
	        return new TransformObservable(this, transform, revert);
	        // if (typeof transformer === 'function') {
	        //   return new TransformObservable<T, U>(this, {transform: transformer as TransformFn<T, U>})
	        // }
	        // return new TransformObservable<T, U>(this, transformer as Transformer<T, U>)
	    };
	    /*
	     *  Boolean methods
	     */
	    /**
	     * true when this._value > value
	     */
	    Observable.prototype.gt = function (value) {
	        return exports.o.merge({ lhs: this, rhs: value }).tf(function (v) { return v.lhs > v.rhs; });
	    };
	    /**
	     * true when this._value < value
	     */
	    Observable.prototype.lt = function (value) {
	        return exports.o.merge({ lhs: this, rhs: value }).tf(function (v) { return v.lhs < v.rhs; });
	    };
	    /**
	     * true when this._value === value
	     */
	    Observable.prototype.eq = function (value) {
	        return exports.o.merge({ lhs: this, rhs: value }).tf(function (v) { return v.lhs === v.rhs; });
	    };
	    /**
	     * true when this._value !== value
	     */
	    Observable.prototype.ne = function (value) {
	        return exports.o.merge({ lhs: this, rhs: value }).tf(function (v) { return v.lhs !== v.rhs; });
	    };
	    /**
	     * true when this._value >= value
	     */
	    Observable.prototype.gte = function (value) {
	        return exports.o.merge({ lhs: this, rhs: value }).tf(function (v) { return v.lhs >= v.rhs; });
	    };
	    /**
	     * true when this._value <= value
	     */
	    Observable.prototype.lte = function (value) {
	        return exports.o.merge({ lhs: this, rhs: value }).tf(function (v) { return v.lhs <= v.rhs; });
	    };
	    /**
	     * true when this._value is null or undefined
	     */
	    Observable.prototype.isNull = function () {
	        return this.tf(function (val) { return val == null; });
	    };
	    /**
	     * true when this._value is neither null nor undefined
	     */
	    Observable.prototype.isNotNull = function () {
	        return this.tf(function (val) { return val != null; });
	    };
	    /**
	     * true when this._value is strictly undefined
	     */
	    Observable.prototype.isUndefined = function () {
	        return this.tf(function (val) { return val === undefined; });
	    };
	    /**
	     * true when this._value is strictly not undefined
	     */
	    Observable.prototype.isDefined = function () {
	        return this.tf(function (val) { return val !== undefined; });
	    };
	    /**
	     * true when this._value is === false
	     */
	    Observable.prototype.isFalse = function () {
	        return this.tf(function (val) { return val === false; });
	    };
	    /**
	     * true when this._value === true
	     */
	    Observable.prototype.isTrue = function () {
	        return this.tf(function (val) { return val === true; });
	    };
	    /**
	     * true when this._value would be false in an if condition
	     */
	    Observable.prototype.isFalsy = function () {
	        return this.tf(function (val) { return !val; });
	    };
	    /**
	     * true when this._value would be true in an if condition
	     */
	    Observable.prototype.isTruthy = function () {
	        return this.tf(function (val) { return !!val; });
	    };
	    /**
	     * Set up an observable that is true when this observable or
	     * any of the provided observables is true.
	     */
	    Observable.prototype.or = function () {
	        var args = [];
	        for (var _i = 0; _i < arguments.length; _i++) {
	            args[_i] = arguments[_i];
	        }
	        return exports.o.or.apply(exports.o, [this].concat(args));
	    };
	    /**
	     * True when this and all the values provided in args are true.
	     */
	    Observable.prototype.and = function () {
	        var args = [];
	        for (var _i = 0; _i < arguments.length; _i++) {
	            args[_i] = arguments[_i];
	        }
	        return exports.o.and.apply(exports.o, [this].concat(args));
	    };
	    /**
	     * Set the value of this observable to "not" its value.
	     *
	     * Will trigger a compilation error if used with something else than
	     * a boolean Observable.
	     */
	    Observable.prototype.toggle = function () {
	        this.set(!this._value);
	    };
	    Observable.prototype.add = function (inc) {
	        this.set(this._value + inc);
	        return this;
	    };
	    Observable.prototype.sub = function (dec) {
	        this.set(this._value - dec);
	        return this;
	    };
	    Observable.prototype.mul = function (coef) {
	        this.set(this._value * coef);
	        return this;
	    };
	    Observable.prototype.div = function (coef) {
	        this.set(this._value / coef);
	        return this;
	    };
	    Observable.prototype.mod = function (m) {
	        this.set(this._value % m);
	        return this;
	    };
	    // ARRAY METHODS
	    Observable.prototype.push = function (v) {
	        var res = this._value.push(v);
	        this.notify(C.create(this._value, this._value)
	            .set('length', C.create(this._value.length, this._value.length - 1))
	            .set(this._value.length - 1, C.create(v)));
	        return res;
	    };
	    Observable.prototype.pop = function () {
	        if (this._value.length === 0)
	            return;
	        var res = this._value.pop();
	        this.notify(C.create(this._value, this._value)
	            .set('length', C.create(this._value.length, this._value.length + 1))
	            .set(this._value.length, C.create()));
	        return res;
	    };
	    Observable.prototype.shift = function () {
	        var res = this._value.shift();
	        // this should retrigger all the prop observables.
	        this.notify();
	        return res;
	    };
	    Observable.prototype.unshift = function (v) {
	        var res = this._value.unshift(v);
	        this.notify();
	        return res;
	    };
	    Observable.prototype.sort = function (fn) {
	        // FIXME sort function type
	        var res = this._value.sort(fn);
	        this.notify();
	        return res;
	    };
	    Observable.prototype.splice = function (start, deleteCount) {
	        var items = [];
	        for (var _i = 2; _i < arguments.length; _i++) {
	            items[_i - 2] = arguments[_i];
	        }
	        // FIXME arguments
	        var res = (_a = this._value).splice.apply(_a, [start, deleteCount].concat(items));
	        this.notify();
	        return res;
	        var _a;
	    };
	    Observable.prototype.reverse = function () {
	        var res = this._value.reverse();
	        this.notify();
	        return res;
	    };
	    Observable.prototype.concat = function (arr) {
	        var res = this._value = this._value.concat(arr);
	        this.notify();
	        return res;
	    };
	    //////////////////////////////////////
	    Observable.prototype.map = function (fn) {
	        return this.tf(function (arr) { return Array.isArray(arr) ? arr.map(fn) : []; });
	    };
	    Observable.prototype.filter = function (fn) {
	        return this.tf(function (arr) { return Array.isArray(arr) ? arr.filter(fn) : []; });
	    };
	    Observable.prototype.join = function (separator) {
	        return this.tf(function (arr) { return Array.isArray(arr) ? arr.join(separator) : ''; });
	    };
	    return Observable;
	}());
	exports.Observable = Observable;
	/**
	 * An observable that depends on another or several others
	 */
	var DependantObservable = (function (_super) {
	    __extends(DependantObservable, _super);
	    function DependantObservable() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    DependantObservable.prototype.get = function (prop) {
	        if (!this.isBeingObserved()) {
	            this._refresh();
	        }
	        return _super.prototype.get.call(this, prop);
	    };
	    DependantObservable.prototype.addObserver = function (fn, options, prop) {
	        if (!this.isBeingObserved()) {
	            this._setupUnregisterFn();
	        }
	        return _super.prototype.addObserver.call(this, fn, options, prop);
	    };
	    DependantObservable.prototype.removeObserver = function (fn, path) {
	        _super.prototype.removeObserver.call(this, fn, path);
	        if (this._observers_count === 0 && this._unregister) {
	            this._unregister();
	            this._unregister = null;
	        }
	    };
	    return DependantObservable;
	}(Observable));
	exports.DependantObservable = DependantObservable;
	var MergeObservable = (function (_super) {
	    __extends(MergeObservable, _super);
	    function MergeObservable(deps) {
	        var _this = _super.call(this, {}) // will be overridden later on
	         || this;
	        _this.deps = deps;
	        return _this;
	    }
	    MergeObservable.prototype._refresh = function () {
	        for (var x in this.deps)
	            this._value[x] = exports.o.get(this.deps[x]);
	    };
	    MergeObservable.prototype.set = function (prop, value) {
	        if (typeof value !== 'undefined') {
	            // we have a sub value we want to set.
	            var dep = this.deps[prop];
	            if (dep instanceof Observable) {
	                return dep.set(value);
	            }
	            // Dep wasn't an observable !
	            var old = this.deps[prop];
	            this.deps[prop] = value;
	            this._value[prop] = value;
	            this.notify(C.noop(this._value)
	                .set(prop, C.create(value, old)));
	            return old !== value;
	        }
	        else {
	            for (var x in prop) {
	                var dep2 = this.deps[x];
	                if (dep2 instanceof Observable) {
	                    dep2.set(prop[x]);
	                }
	                else {
	                    this.deps[x] = prop[x];
	                }
	            }
	            return true;
	        }
	    };
	    MergeObservable.prototype.prop = function (prop) {
	        var dep = this.deps[prop];
	        return dep instanceof Observable ? dep : _super.prototype.prop.call(this, prop);
	    };
	    // We need to override prop so that it gives the correct object
	    MergeObservable.prototype._setupUnregisterFn = function () {
	        var _this = this;
	        var unregs = [];
	        this.pauseObserving();
	        var _loop_1 = function (x) {
	            dep = this_1.deps[x];
	            if (dep instanceof Observable) {
	                unregs.push(dep.addObserver(function (val, changes) {
	                    _this._value[x] = val; // typescript gets confused here.
	                    _this.notify(C.noop(_this._value)
	                        .set(x, C.create(val, changes ? changes.old_value : undefined)));
	                }));
	            }
	            else
	                this_1._value[x] = this_1.deps[x];
	        };
	        var this_1 = this, dep;
	        for (var x in this.deps) {
	            _loop_1(x);
	        }
	        this.resumeObserving();
	        this._unregister = function () { unregs.forEach(function (d) { return d(); }); };
	    };
	    return MergeObservable;
	}(DependantObservable));
	exports.MergeObservable = MergeObservable;
	var IndexableObservable = (function (_super) {
	    __extends(IndexableObservable, _super);
	    function IndexableObservable(deps) {
	        var _this = _super.call(this, {}) || this;
	        _this.deps = {};
	        _this.unregs = {};
	        _this.count = 0;
	        for (var x in deps) {
	            _this.addDependency(x, deps[x]);
	        }
	        return _this;
	    }
	    IndexableObservable.prototype.addDependency = function (name, dep) {
	        this.deps[name] = dep;
	        this.count++;
	        if (!(dep instanceof Observable))
	            this._value[name] = dep;
	    };
	    IndexableObservable.prototype.hasDependency = function (name) {
	        return this.deps[name] != null;
	    };
	    IndexableObservable.prototype.removeDependency = function (arg) {
	        var name = '';
	        if (typeof arg === 'string')
	            name = arg;
	        else {
	            for (var x in this.deps) {
	                if (this.deps[x] === arg) {
	                    name = x;
	                    break;
	                }
	                // Fail silently
	                if (!name)
	                    return;
	            }
	        }
	        if (this.deps[name])
	            this.count--;
	        delete this._value[name];
	        delete this.deps[name];
	        // Also unregister observing.
	        if (this.unregs[name]) {
	            this.unregs[name]();
	            delete this.unregs[name];
	        }
	    };
	    return IndexableObservable;
	}(MergeObservable));
	exports.IndexableObservable = IndexableObservable;
	/**
	 * An Observable based on another observable, watching only its subpath.
	 */
	var PropObservable = (function (_super) {
	    __extends(PropObservable, _super);
	    function PropObservable(_obs, _prop) {
	        var _this = _super.call(this, undefined) // FUCK YOU type checker that's why
	         || this;
	        _this._obs = _obs;
	        _this._prop = _prop;
	        return _this;
	    }
	    PropObservable.prototype.isPaused = function () {
	        return this._obs.isPaused();
	    };
	    PropObservable.prototype.set = function (prop, value) {
	        if (!this.isBeingObserved() || this.isPaused())
	            this._refresh(); // we want to be sure we're up to date
	        // with the upward object.
	        if (arguments.length > 1) {
	            var current = this._value;
	            var old = current[prop];
	            // do nothing if the value is the same.
	            if (old === value)
	                return false;
	            current[prop] = value;
	            // Now, find the top most observable that is not a PropObservable
	            // and notify it of the change.
	            var chg = C.noop(current)
	                .set(prop, C.create(value, old));
	            var iter = this;
	            while (iter instanceof PropObservable) {
	                chg = C.noop(iter._obs.get())
	                    .set(iter._prop, chg);
	                iter = iter._obs;
	            }
	            iter.notify(chg);
	            return true;
	        }
	        else {
	            // If no sub-prop is mentionned, just delegate the set
	            return this._obs.set(this._prop, prop);
	        }
	    };
	    /**
	     * Setup listening to the parent observable
	     */
	    PropObservable.prototype._setupUnregisterFn = function () {
	        var _this = this;
	        this._unregister = this._obs.addObserver(function (value, changes) {
	            // we need to use this trick because typescript makes no link between U and T
	            var chg = changes;
	            if (typeof changes.old_value === 'undefined')
	                chg.old_value = _this._value;
	            _this._refresh();
	            _this.notify(chg);
	        }, {}, this._prop);
	    };
	    PropObservable.prototype._refresh = function () {
	        this._value = this._obs.get(this._prop);
	    };
	    PropObservable.prototype.prop = function (prop) {
	        return new PropObservable(this, prop);
	    };
	    PropObservable.prototype.oHasNext = function () {
	        var _this = this;
	        return this._obs.p('length').tf(function (len) { return parseInt(_this._prop) < len - 1; });
	    };
	    PropObservable.prototype.oHasPrev = function () {
	        var _this = this;
	        return this._obs.p('length').tf(function (len) { return parseInt(_this._prop) > 0 && len > 0; });
	    };
	    PropObservable.prototype.next = function () {
	        return new PropObservable(this._obs, parseInt(this._prop) + 1);
	    };
	    PropObservable.prototype.prev = function () {
	        return new PropObservable(this._obs, parseInt(this._prop) - 1);
	    };
	    PropObservable.prototype.getProp = function () {
	        return this._prop;
	    };
	    /**
	     * Change the property being watched
	     */
	    PropObservable.prototype.setProp = function (p) {
	        this._prop = p;
	        // If we're being observed, notify the change.
	        if (this._unregister) {
	            this._refresh();
	        }
	    };
	    /**
	     * If the underlying observable is an array, go to the next item.
	     */
	    PropObservable.prototype.nextProp = function () {
	        this.setProp(parseInt(this._prop) + 1);
	    };
	    /**
	     * If the underlying observable is an array, go to the previous item.
	     */
	    PropObservable.prototype.prevProp = function () {
	        this.setProp(parseInt(this._prop) - 1);
	    };
	    return PropObservable;
	}(DependantObservable));
	exports.PropObservable = PropObservable;
	var TransformObservable = (function (_super) {
	    __extends(TransformObservable, _super);
	    function TransformObservable(_obs, _transform, _revert) {
	        var _this = _super.call(this, null) || this;
	        _this._obs = _obs;
	        _this._transform = _transform;
	        _this._revert = _revert;
	        _this._value = _transform.call(_this, _obs.get(), C.noop(_obs.get()));
	        return _this;
	    }
	    TransformObservable.prototype.set = function (value, value2) {
	        var cur = this._value;
	        var old_value = this._value;
	        var final_value = value;
	        if (!this._revert)
	            throw new Error('this transformer has no set method.');
	        var chg = C.create(final_value, old_value);
	        if (arguments.length > 1) {
	            final_value = cur;
	            var old_prop = cur[value];
	            cur[value] = value2;
	            chg = C.create(cur, old_value)
	                .set(value, C.create(cur[value], old_prop));
	            // A set should be made
	            this._value[value] = value2;
	        }
	        // FIXME this is most likely incorrect
	        this._revert(this._obs, final_value, chg);
	        return true;
	    };
	    TransformObservable.prototype._refresh = function () {
	        // FIXME changes here are most likely incorrect.
	        this._value = this._transform(this._obs.get(), C.noop(this._obs.get()));
	    };
	    TransformObservable.prototype._setupUnregisterFn = function () {
	        var _this = this;
	        this._unregister = this._obs.addObserver(function (value, changes) {
	            var old = _this._value;
	            _this._refresh();
	            // do not call if the value of the object did not change.
	            if (old !== _this._value)
	                _this.notify(C.create(_this._value, old));
	        });
	    };
	    return TransformObservable;
	}(DependantObservable));
	exports.TransformObservable = TransformObservable;
	/**
	 *
	 */
	exports.o = function o(value) {
	    return value instanceof Observable ? value : new Observable(value);
	};
	/**
	 *
	 */
	exports.o.get = function (v) {
	    return v instanceof Observable ? v.get() : v;
	};
	/**
	 * Call the observer whenever the observable changes. If `obs` was not observable,
	 * just call the observer directly, unless the options specified `updatesOnly` in which
	 * case nothing happen.
	 */
	exports.o.observe = function (obs, observer, options) {
	    if (obs instanceof Observable)
	        return obs.addObserver(observer, options);
	    // Call immediately the observer since the maybe observable wasn't observable,
	    // unless we wanted only the changes, in which case this will never occur.
	    if (!options || !options.updatesOnly)
	        observer(obs, C.create(obs));
	    return function () { };
	};
	exports.o.merge = function merge(obj) {
	    return new MergeObservable(obj);
	};
	exports.o.indexable = function indexable(obj) {
	    return new IndexableObservable(obj);
	};
	exports.o.or = function or() {
	    var a = [];
	    for (var _i = 0; _i < arguments.length; _i++) {
	        a[_i] = arguments[_i];
	    }
	    var deps = {};
	    for (var i = 0; i < a.length; i++)
	        deps[i] = a[i];
	    return exports.o.indexable(deps)
	        .tf(function (all) {
	        for (var x in all) {
	            if (all[x])
	                return true;
	        }
	        return false;
	    });
	};
	exports.o.and = function and() {
	    var a = [];
	    for (var _i = 0; _i < arguments.length; _i++) {
	        a[_i] = arguments[_i];
	    }
	    var deps = {};
	    for (var i = 0; i < a.length; i++)
	        deps[i] = a[i];
	    return exports.o.indexable(deps)
	        .tf(function (all) {
	        for (var x in all) {
	            if (!all[x])
	                return false;
	        }
	        return true;
	    });
	};


/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var domic_observable_1 = __webpack_require__(2);
	var Controller = (function () {
	    function Controller() {
	        this.mounted = false;
	        this.onmount = this.onmount ? this.onmount.slice() : [];
	        this.onunmount = this.onunmount ? this.onunmount.slice() : [];
	        this.onrender = this.onrender ? this.onrender.slice() : [];
	    }
	    Controller.getIfExists = function (node) {
	        var iter = node;
	        while (iter) {
	            for (var _i = 0, _a = iter._domic_controllers || []; _i < _a.length; _i++) {
	                var c = _a[_i];
	                if (c instanceof this)
	                    return c;
	            }
	            iter = iter.parentNode;
	        }
	        return null;
	    };
	    /**
	     * Recursively find a controller starting at a node and making its
	     * way up.
	     */
	    Controller.get = function (node) {
	        var res = this.getIfExists(node);
	        if (!res)
	            throw new Error("Controller " + this.name + " was not found on this node");
	        return res;
	    };
	    /**
	     * Get all the controllers for a given node.
	     *
	     * @returns undefined if the node was not associated with a controller array
	     */
	    Controller.all = function (node) {
	        return node._domic_controllers;
	    };
	    /**
	     * Get all the controllers for a Node. If there was no controller array,
	     * setup a new one.
	     */
	    Controller.init = function (node) {
	        if (!node._domic_controllers)
	            node._domic_controllers = [];
	        return node._domic_controllers;
	    };
	    /**
	     * Associate a Controller to a Node.
	     */
	    Controller.prototype.bindToNode = function (node) {
	        this.node = node;
	        Controller.init(node).push(this);
	    };
	    Controller.prototype.observe = function (a, cbk, options) {
	        var unload;
	        var obs = domic_observable_1.o(a);
	        this.onmount.push(function () {
	            if (!unload)
	                unload = obs.addObserver(cbk, options);
	        });
	        this.onunmount.push(function () {
	            if (unload)
	                unload();
	            unload = null;
	        });
	        // Add the observer right now if it turns out we're already mounted.
	        if (this.mounted)
	            unload = obs.addObserver(cbk, options);
	        return this;
	    };
	    /**
	     * Observe an observer but only when it changes, do not call the callback
	     * right away like observe. (?)
	     */
	    Controller.prototype.observeChanges = function () {
	        return this;
	    };
	    return Controller;
	}());
	exports.Controller = Controller;
	/**
	 * Useless controller just used to register observables used by class or style
	 */
	var DefaultController = (function (_super) {
	    __extends(DefaultController, _super);
	    function DefaultController() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    DefaultController.get = function (n) {
	        var d = _super.getIfExists.call(this, n);
	        if (!d) {
	            d = new DefaultController();
	            d.bindToNode(n);
	        }
	        return d;
	    };
	    return DefaultController;
	}(Controller));
	exports.DefaultController = DefaultController;
	/**
	 *
	 */
	function ctrl() {
	    var ctrls = [];
	    for (var _i = 0; _i < arguments.length; _i++) {
	        ctrls[_i] = arguments[_i];
	    }
	    return function (node) {
	        var instance = null;
	        for (var _i = 0, ctrls_1 = ctrls; _i < ctrls_1.length; _i++) {
	            var c = ctrls_1[_i];
	            if (c instanceof Controller) {
	                instance = c;
	            }
	            else {
	                instance = new c;
	            }
	            Controller.init(node).push(instance);
	        }
	    };
	}
	exports.ctrl = ctrl;
	/**
	 * attrs is not set in the constructor, but will be in render()
	 */
	var Component = (function (_super) {
	    __extends(Component, _super);
	    function Component(attrs) {
	        var _this = _super.call(this) || this;
	        _this.attrs = attrs;
	        return _this;
	    }
	    return Component;
	}(Controller));
	exports.Component = Component;
	var HTMLComponent = (function (_super) {
	    __extends(HTMLComponent, _super);
	    function HTMLComponent() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    return HTMLComponent;
	}(Component));
	exports.HTMLComponent = HTMLComponent;


/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	/**
	 * Control structures to help with readability.
	 */
	var domic_observable_1 = __webpack_require__(2);
	var domic_1 = __webpack_require__(1);
	var decorators_1 = __webpack_require__(5);
	var controller_1 = __webpack_require__(3);
	/**
	 * Base Component for components not using DOM Elements.
	 *
	 * Rendered as a several Comment nodes, it keeps its children
	 * between a starting and an ending Comment (called `begin` and
	 * `end` internally) which are kept immediately *after* `this.node`
	 */
	var VirtualHolder = (function (_super) {
	    __extends(VirtualHolder, _super);
	    function VirtualHolder() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        /**
	         * A string used to keep track in the DOM of who we are.
	         */
	        _this.name = 'virtual';
	        return _this;
	    }
	    VirtualHolder.prototype.render = function (children) {
	        this.begin = document.createComment(" (( ");
	        this.end = document.createComment(" ))");
	        if (children) {
	            children.insertBefore(this.begin, children.firstChild);
	            children.appendChild(this.end);
	            this.saved_children = children;
	        }
	        return document.createComment(" " + this.name + ": ");
	    };
	    VirtualHolder.prototype.createOrAppendChildren = function (node) {
	        // we force the type to Node as in theory when @onmount is called
	        // the parent is guaranteed to be defined
	        var parent = node.parentNode;
	        var next = node.nextSibling;
	        if (this.saved_children) {
	            parent.insertBefore(this.saved_children, next);
	            this.saved_children = null;
	        }
	        else if (!this.begin.parentNode) {
	            parent.insertBefore(this.begin, next);
	            parent.insertBefore(this.end, next);
	        }
	    };
	    VirtualHolder.prototype.unmountChildrenIfNeeded = function (node) {
	        var _this = this;
	        // If we have a parentNode in an unmount() method, it means
	        // that we were not unmounted directly.
	        // If there is no parentNode, `this.node` was specifically
	        // removed from the DOM and since we keep our children
	        // after `this.node`, we need to remove them as well.
	        if (!node.parentNode) {
	            requestAnimationFrame(function () {
	                var fragment = document.createDocumentFragment();
	                var iter = _this.begin;
	                var next = null;
	                while (iter) {
	                    next = iter.nextSibling;
	                    fragment.appendChild(iter);
	                    if (iter === _this.end)
	                        break;
	                    iter = next;
	                }
	                _this.saved_children = fragment;
	            });
	        }
	    };
	    VirtualHolder.prototype.updateChildren = function (node) {
	        this.next_node = node;
	        var iter = this.begin.nextSibling;
	        var end = this.end;
	        var next = null;
	        if (!iter) {
	            // If we're here, we're most likely not mounted, so we will
	            // put the next node into saved_children instead.
	            this.saved_children = this.next_node;
	            this.next_node = null;
	            return;
	        }
	        var parent = iter.parentNode;
	        if (!parent)
	            return;
	        while (iter && iter !== end) {
	            next = iter.nextSibling;
	            parent.removeChild(iter);
	            iter = next;
	        }
	        if (this.next_node)
	            parent.insertBefore(this.next_node, end);
	        this.next_node = null;
	    };
	    return VirtualHolder;
	}(controller_1.Component));
	__decorate([
	    decorators_1.onmount
	], VirtualHolder.prototype, "createOrAppendChildren", null);
	__decorate([
	    decorators_1.onunmount
	], VirtualHolder.prototype, "unmountChildrenIfNeeded", null);
	exports.VirtualHolder = VirtualHolder;
	var Writer = (function (_super) {
	    __extends(Writer, _super);
	    function Writer() {
	        return _super !== null && _super.apply(this, arguments) || this;
	    }
	    Writer.prototype.render = function () {
	        var node = document.createTextNode('');
	        this.observe(this.attrs.obs, function (value) {
	            node.nodeValue = value != null ? value.toString() : '';
	        });
	        return node;
	    };
	    return Writer;
	}(controller_1.Component));
	exports.Writer = Writer;
	/**
	 * Write and update the string value of an observable value into
	 * a Text node.
	 */
	function Write(obs) {
	    return domic_1.d(Writer, { obs: obs });
	}
	exports.Write = Write;
	var Displayer = (function (_super) {
	    __extends(Displayer, _super);
	    function Displayer() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.name = 'if';
	        return _this;
	    }
	    Displayer.prototype.render = function () {
	        var _this = this;
	        this.observe(domic_observable_1.o.merge({
	            condition: this.attrs.condition,
	            display: this.attrs.display,
	            otherwise: this.attrs.display_otherwise
	        }), function (_a) {
	            var condition = _a.condition, display = _a.display, otherwise = _a.otherwise;
	            if ((typeof _this.attrs.condition) !== 'undefined' && !condition) {
	                if (otherwise)
	                    return _this.updateChildren(typeof otherwise === 'function' ? otherwise(condition) : otherwise);
	                return _this.updateChildren(null);
	            }
	            _this.updateChildren(typeof display === 'function' ? display(condition) : display);
	        });
	        return _super.prototype.render.call(this);
	    };
	    return Displayer;
	}(VirtualHolder));
	exports.Displayer = Displayer;
	function Display(display) {
	    return domic_1.d(Displayer, { display: display });
	}
	exports.Display = Display;
	/**
	 *
	 */
	function DisplayIf(condition, display, display_otherwise) {
	    return domic_1.d(Displayer, { condition: domic_observable_1.o(condition), display: display, display_otherwise: display_otherwise });
	}
	exports.DisplayIf = DisplayIf;
	function DisplayUnless(condition, display, display_otherwise) {
	    return domic_1.d(Displayer, { condition: domic_observable_1.o(condition).isFalsy(), display: display, display_otherwise: display_otherwise });
	}
	exports.DisplayUnless = DisplayUnless;
	/**
	 *
	 */
	var Repeater = (function (_super) {
	    __extends(Repeater, _super);
	    function Repeater() {
	        var _this = _super !== null && _super.apply(this, arguments) || this;
	        _this.positions = [];
	        _this.index = -1;
	        _this.lst = [];
	        _this.prop_obs = false;
	        _this.parent = null;
	        _this.child_obs = [];
	        return _this;
	    }
	    Repeater.prototype.reset = function (lst) {
	        this.lst = lst;
	        this.index = -1;
	        this.positions = [];
	        for (var _i = 0, _a = this.child_obs; _i < _a.length; _i++) {
	            var ob = _a[_i];
	            ob._unregister();
	            ob._unregister = null;
	        }
	        this.child_obs = [];
	        this.updateChildren(null);
	    };
	    /**
	     * If we are dependant to the scroll, return false
	     */
	    Repeater.prototype.next = function () {
	        if (this.index >= this.lst.length - 1)
	            return null;
	        this.index++;
	        var comment = document.createComment('repeat-' + this.index);
	        var fr = document.createDocumentFragment();
	        var ob = this.prop_obs ? this.obs.p(this.index) : this.lst[this.index];
	        if (this.prop_obs)
	            this.child_obs.push(ob);
	        fr.appendChild(comment);
	        fr.appendChild(this.renderfn(ob, this.index));
	        this.positions.push(comment);
	        return fr;
	    };
	    Repeater.prototype.draw = function () {
	        if (!this.node.parentNode)
	            return;
	        var diff = this.lst.length - this.positions.length;
	        var next = null;
	        var parent = this.end.parentNode;
	        if (diff > 0) {
	            if (!this.attrs.scroll) {
	                var fr = document.createDocumentFragment();
	                while (next = this.next()) {
	                    fr.appendChild(next);
	                }
	                parent.insertBefore(fr, this.end);
	            }
	            else {
	                var bufsize = this.attrs.scroll_buffer_size || 10;
	                var count = 0;
	                var p = this.parent;
	                while (p.scrollHeight - (p.clientHeight + p.scrollTop) < 500) {
	                    var fr = document.createDocumentFragment();
	                    while ((next = this.next()) && count++ < bufsize) {
	                        fr.appendChild(next);
	                    }
	                    parent.insertBefore(fr, this.end);
	                    count = 0;
	                    if (!next)
	                        break;
	                }
	            }
	        }
	        else if (diff < 0) {
	            // Détruire jusqu'à la position concernée...
	            var iter = this.positions[this.lst.length];
	            var end = this.end;
	            if (this.prop_obs) {
	                for (var k = this.lst.length; k < this.child_obs.length; k++) {
	                    var ob = this.child_obs[k];
	                    ob._unregister();
	                    ob._unregister = null;
	                }
	                this.child_obs = this.child_obs.slice(0, this.lst.length);
	            }
	            while (iter && iter !== end) {
	                next = iter.nextSibling;
	                parent.removeChild(iter);
	                iter = next;
	            }
	            this.positions = this.positions.slice(0, this.lst.length);
	        }
	    };
	    Repeater.prototype.setupScrolling = function () {
	        if (!this.attrs.scroll)
	            return;
	        // Find parent with the overflow-y
	        var iter = this.node.parentElement;
	        while (iter) {
	            var over = getComputedStyle(iter).overflowY;
	            if (over === 'auto') {
	                this.parent = iter;
	                break;
	            }
	            iter = iter.parentElement;
	        }
	        if (!this.parent)
	            throw new Error("Scroll repeat needs a parent with overflow-y: auto");
	        this.parent.addEventListener('scroll', this.draw);
	    };
	    Repeater.prototype.removeScrolling = function () {
	        if (!this.attrs.scroll || !this.parent)
	            return;
	        this.parent.removeEventListener('scroll', this.draw);
	        this.parent = null;
	    };
	    Repeater.prototype.render = function () {
	        var _this = this;
	        this.obs = domic_observable_1.o(this.attrs.ob);
	        this.renderfn = this.attrs.render;
	        // Bind draw so that we can unregister it
	        this.draw = this.draw.bind(this);
	        this.prop_obs = this.attrs.use_prop_observable || false;
	        var old_value = null;
	        this.observe(this.obs, function (lst, change) {
	            lst = lst || [];
	            if (lst !== old_value)
	                _this.reset(lst);
	            old_value = lst;
	            _this.draw();
	        });
	        return _super.prototype.render.call(this);
	    };
	    return Repeater;
	}(VirtualHolder));
	__decorate([
	    decorators_1.onmount
	], Repeater.prototype, "setupScrolling", null);
	__decorate([
	    decorators_1.onunmount
	], Repeater.prototype, "removeScrolling", null);
	exports.Repeater = Repeater;
	/**
	 *
	 */
	function Repeat(ob, render) {
	    return domic_1.d(Repeater, { ob: ob, render: render });
	}
	exports.Repeat = Repeat;
	function RepeatObservable(ob, render) {
	    return domic_1.d(Repeater, { ob: ob, render: render, use_prop_observable: true });
	}
	exports.RepeatObservable = RepeatObservable;
	function RepeatScroll(ob, render, options) {
	    if (options === void 0) { options = {}; }
	    return domic_1.d(Repeater, { ob: ob, render: render, scroll: true, scroll_buffer_size: options.scroll_buffer_size });
	}
	exports.RepeatScroll = RepeatScroll;
	function RepeatScrollObservable(ob, render, options) {
	    if (options === void 0) { options = {}; }
	    return domic_1.d(Repeater, { ob: ob, render: render,
	        use_prop_observable: true,
	        scroll: true,
	        scroll_buffer_size: options.scroll_buffer_size
	    });
	}
	exports.RepeatScrollObservable = RepeatScrollObservable;
	/**
	 *
	 */
	function Fragment(attrs, children) {
	    return children;
	}
	exports.Fragment = Fragment;


/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var __extends = (this && this.__extends) || (function () {
	    var extendStatics = Object.setPrototypeOf ||
	        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
	        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
	    return function (d, b) {
	        extendStatics(d, b);
	        function __() { this.constructor = d; }
	        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
	    };
	})();
	var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
	    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
	    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
	    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
	    return c > 3 && r && Object.defineProperty(target, key, r), r;
	};
	var controller_1 = __webpack_require__(3);
	var BindController = (function (_super) {
	    __extends(BindController, _super);
	    function BindController(obs, opts) {
	        if (opts === void 0) { opts = {}; }
	        var _this = _super.call(this) || this;
	        _this.obs = obs;
	        _this.opts = opts;
	        return _this;
	    }
	    BindController.prototype.link = function (node) {
	        if (node instanceof HTMLInputElement)
	            this.linkToInput(node);
	        if (node instanceof HTMLSelectElement)
	            this.linkToSelect(node);
	        if (node instanceof HTMLTextAreaElement)
	            this.linkToTextArea(node);
	        if (node instanceof HTMLElement && node.contentEditable)
	            this.linkToHTML5Editable(node);
	    };
	    BindController.prototype.linkToTextArea = function (node) {
	        var obs = this.obs;
	        function upd(evt) {
	            obs.set(node.value);
	        }
	        node.addEventListener('input', upd);
	        node.addEventListener('change', upd);
	        node.addEventListener('propertychange', upd);
	        this.observe(obs, function (val) {
	            node.value = val || '';
	        }, this.opts);
	    };
	    BindController.prototype.linkToSelect = function (node) {
	        var obs = this.obs;
	        node.addEventListener('change', function (evt) {
	            obs.set(node.value);
	        });
	        this.observe(obs, function (val) {
	            node.value = val;
	        }, this.opts);
	    };
	    BindController.prototype.linkToInput = function (node) {
	        var obs = this.obs;
	        var value_set_from_event = false;
	        var fromObservable = function (val) {
	            if (value_set_from_event)
	                return;
	            node.value = val == null ? '' : val;
	        };
	        var fromEvent = function (evt) {
	            var val = node.value;
	            value_set_from_event = true;
	            obs.set(val);
	            value_set_from_event = false;
	        };
	        var type = node.type.toLowerCase() || 'text';
	        switch (type) {
	            case 'color':
	            case 'range':
	            case 'date':
	            case 'datetime':
	            case 'week':
	            case 'month':
	            case 'time':
	            case 'datetime-local':
	                this.observe(obs, fromObservable, this.opts);
	                node.addEventListener('input', fromEvent);
	                break;
	            case 'radio':
	                this.observe(obs, function (val) {
	                    // !!!? ??
	                    node.checked = node.value === val;
	                }, this.opts);
	                node.addEventListener('change', fromEvent);
	                break;
	            case 'checkbox':
	                // FIXME ugly hack because we specified string
	                this.observe(obs, function (val) {
	                    node.checked = !!val;
	                }, this.opts);
	                node.addEventListener('change', function () { return obs.set(node.checked); });
	                break;
	            // case 'number':
	            // case 'text':
	            // case 'password':
	            // case 'search':
	            default:
	                this.observe(obs, fromObservable, this.opts);
	                node.addEventListener('keyup', fromEvent);
	                node.addEventListener('input', fromEvent);
	                node.addEventListener('change', fromEvent);
	        }
	    };
	    BindController.prototype.linkToHTML5Editable = function (element) {
	        // FIXME
	    };
	    return BindController;
	}(controller_1.Controller));
	__decorate([
	    onrender
	], BindController.prototype, "link", null);
	exports.BindController = BindController;
	function bind(obs, opts) {
	    if (opts === void 0) { opts = {}; }
	    return function bindDecorator(node) {
	        var c = new BindController(obs, opts);
	        c.bindToNode(node);
	    };
	}
	exports.bind = bind;
	function observe(a, cbk, options) {
	    return function observeDecorator(node) {
	        var c = controller_1.DefaultController.get(node);
	        c.observe(a, cbk, options);
	    };
	}
	exports.observe = observe;
	function on(event, listener, useCapture) {
	    if (useCapture === void 0) { useCapture = false; }
	    return function (node) {
	        node.addEventListener(event, listener);
	    };
	}
	exports.on = on;
	/**
	 * Add a callback on the click event, or touchend if we are on a mobile
	 * device.
	 */
	function click(cbk) {
	    return function clickDecorator(node) {
	        node.addEventListener('click', cbk);
	    };
	}
	exports.click = click;
	// let on_mobile = typeof(window) !== 'undefined' ? /iPad|iPhone|iPod/.test(window.navigator.userAgent) && !(window as any).MSStream : false
	exports.THRESHOLD = 300; // 10 milliseconds
	exports.DISTANCE_THRESHOLD = 10;
	var _ghost_done = new WeakMap();
	function _disable_ghost_click(n) {
	    if (_ghost_done.get(n.ownerDocument))
	        return;
	    _ghost_done.set(n.ownerDocument, true);
	    var last_fake = Date.now();
	    n.ownerDocument.body.addEventListener('click', function (ev) {
	        if (ev.detail === -1) {
	            last_fake = Date.now();
	        }
	        if (Date.now() - last_fake < exports.THRESHOLD * 2 && ev.detail !== -1) {
	            ev.preventDefault();
	            ev.stopPropagation();
	        }
	    }, true);
	}
	function clickfix(node) {
	    var lasttarget = null;
	    var lastx = 0;
	    var lasty = 0;
	    var last_call = 0;
	    node.addEventListener('touchstart', function (ev) {
	        lasttarget = ev.target;
	        lastx = ev.touches[0].pageX;
	        lasty = ev.touches[0].pageY;
	        last_call = Date.now();
	    });
	    node.addEventListener('touchend', function (ev) {
	        var now = Date.now();
	        // alert(JSON.stringify(ev))
	        // alert(JSON.stringify(last_ev))
	        var dx = ev.changedTouches[0].pageX - lastx;
	        var dy = ev.changedTouches[0].pageY - lasty;
	        if (lasttarget !== ev.target
	            || now - last_call > exports.THRESHOLD
	            || (dx * dx + dy * dy) > exports.DISTANCE_THRESHOLD * exports.DISTANCE_THRESHOLD) {
	        }
	        else {
	            // If we got here, we can safely call the callback.
	            last_call = now;
	            // alert(JSON.stringify(ev))
	            var init = {
	                altKey: ev.altKey,
	                shiftKey: ev.shiftKey,
	                ctrlKey: ev.ctrlKey,
	                clientX: ev.changedTouches[0].clientX,
	                clientY: ev.changedTouches[0].clientY,
	                detail: -1,
	                bubbles: ev.bubbles,
	                button: 0,
	                cancelable: ev.cancelable,
	                metaKey: ev.metaKey,
	                screenX: ev.changedTouches[0].screenX,
	                screenY: ev.changedTouches[0].screenY,
	            };
	            // alert(JSON.stringify(init))
	            node.dispatchEvent(new MouseEvent('click', init));
	            // cbk(ev, atom)
	            lasttarget = null;
	        }
	    });
	    _disable_ghost_click(node);
	}
	exports.clickfix = clickfix;
	function onmount(target, key) {
	    if (typeof target === 'function') {
	        return function (n) { controller_1.DefaultController.get(n).onmount.push(target); };
	    }
	    var proto = Object.getPrototypeOf(target);
	    if (target.onmount === proto.onmount)
	        target.onmount = (Object.getPrototypeOf(target).onmount || []).slice();
	    target.onmount.push(target[key]);
	}
	exports.onmount = onmount;
	function onfirstmount(target, key) {
	    var fn = typeof target === 'function' ? target : target[key];
	    function first_mount(node) {
	        this.onmount = this.onmount.filter(function (f) { return f !== first_mount; });
	        fn.call(this, node);
	    }
	    if (typeof target === 'function') {
	        return function (n) { controller_1.DefaultController.get(n).onmount.push(first_mount); };
	    }
	    var proto = Object.getPrototypeOf(target);
	    if (target.onmount === proto.onmount)
	        target.onmount = (Object.getPrototypeOf(target).onmount || []).slice();
	    target.onmount.push(first_mount);
	}
	exports.onfirstmount = onfirstmount;
	function onunmount(target, key) {
	    if (typeof target === 'function')
	        return function (n) { controller_1.DefaultController.get(n).onunmount.push(target); };
	    var proto = Object.getPrototypeOf(target);
	    if (target.onunmount === proto.onunmount)
	        target.onunmount = (Object.getPrototypeOf(target).onunmount || []).slice();
	    target.onunmount.push(target[key]);
	}
	exports.onunmount = onunmount;
	function onrender(target, key) {
	    if (typeof target === 'function')
	        return function (n) { controller_1.DefaultController.get(n).onrender.push(target); };
	    var proto = Object.getPrototypeOf(target);
	    if (target.onrender === proto.onrender)
	        target.onrender = (Object.getPrototypeOf(target).onrender || []).slice();
	    target.onrender.push(target[key]);
	}
	exports.onrender = onrender;
	/**
	 * Focus the element when mounted.
	 */
	function focusOnMount(node) {
	    onmount(function (node) { return node.focus(); })(node);
	}
	exports.focusOnMount = focusOnMount;
	var _noscrollsetup = false;
	function _setUpNoscroll() {
	    document.body.addEventListener('touchmove', function event(ev) {
	        // If no div marked as scrollable set the moving attribute, then simply don't scroll.
	        if (!ev.scrollable)
	            ev.preventDefault();
	    }, false);
	    _noscrollsetup = true;
	}
	/**
	 * Setup scroll on an atom so that touchstart and touchmove events don't
	 * trigger the ugly scroll band.
	 *
	 * Calling this functions makes anything not marked scrollable as non-scrollable.
	 */
	function scrollable(nod) {
	    if (!(nod instanceof HTMLElement))
	        throw new Error("scrollable() only works on HTMLElement");
	    var node = nod;
	    if (!_noscrollsetup)
	        _setUpNoscroll();
	    node.style.overflowY = 'auto';
	    node.style.overflowX = 'auto';
	    // seems like typescript doesn't have this property yet
	    node.style.webkitOverflowScrolling = 'touch';
	    node.addEventListener('touchstart', function (ev) {
	        if (node.scrollTop == 0) {
	            node.scrollTop = 1;
	        }
	        else if (node.scrollTop + node.offsetHeight >= node.scrollHeight - 1)
	            node.scrollTop -= 1;
	    }, true);
	    node.addEventListener('touchmove', function event(ev) {
	        if (node.offsetHeight < node.scrollHeight)
	            ev.scrollable = true;
	    }, true);
	}
	exports.scrollable = scrollable;


/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	var controller_1 = __webpack_require__(3);
	function _apply_mount(node) {
	    var controllers = controller_1.Controller.all(node);
	    if (!controllers)
	        return;
	    for (var _i = 0, controllers_1 = controllers; _i < controllers_1.length; _i++) {
	        var c = controllers_1[_i];
	        // ignore spurious unmounts (should not happen, but let's be cautious)
	        if (c.mounted)
	            continue;
	        c.mounted = true;
	        for (var _a = 0, _b = c.onmount; _a < _b.length; _a++) {
	            var f = _b[_a];
	            f.call(c, node, node.parentNode);
	        }
	    }
	}
	exports._apply_mount = _apply_mount;
	/**
	 * Call controllers' mount() functions.
	 */
	function _mount(node, target) {
	    var iter = node;
	    var node_stack = [];
	    // Iterative tree traversal
	    do {
	        _apply_mount(iter);
	        // Push firstChildren first
	        while (iter.firstChild) {
	            node_stack.push(iter);
	            iter = iter.firstChild;
	            _apply_mount(iter);
	        }
	        while (!iter.nextSibling) {
	            iter = node_stack.pop();
	            if (!iter)
	                break;
	        }
	        // So now we're going to traverse the next node.
	        if (iter)
	            iter = iter.nextSibling;
	    } while (iter);
	}
	exports._mount = _mount;
	/**
	 * Apply unmount to a node.
	 */
	function _apply_unmount(tuple) {
	    var node = tuple[0];
	    var controllers = controller_1.Controller.all(node);
	    if (!controllers)
	        return;
	    for (var _i = 0, controllers_2 = controllers; _i < controllers_2.length; _i++) {
	        var c = controllers_2[_i];
	        // ignore spurious unmounts (should not happen, but let's be cautious)
	        if (!c.mounted)
	            continue;
	        c.mounted = false;
	        for (var _a = 0, _b = c.onunmount; _a < _b.length; _a++) {
	            var f = _b[_a];
	            f.apply(c, tuple);
	        }
	    }
	}
	exports._apply_unmount = _apply_unmount;
	/**
	 * Call controller's unmount functions recursively
	 */
	function _unmount(node, target, prev, next) {
	    var unmount = [];
	    var node_stack = [];
	    var iter = node;
	    // We need to store all the nodes for which we'll call unmount() beforehand,
	    // as an unmount() handler may further remove nodes that were already
	    // unmounted from the DOM and which could be missed if we naively traversed
	    // the unmounted children.
	    //
	    // The array construction is done iteratively for performance considerations.
	    do {
	        // Push firstChildren first
	        while (iter.firstChild) {
	            node_stack.push(iter);
	            iter = iter.firstChild;
	        }
	        unmount.push([iter, iter.parentNode || target, null, null]);
	        // When we're here, we're on a terminal node, so
	        // we're going to have to process it.
	        while (!iter.nextSibling) {
	            iter = node_stack.pop();
	            if (!iter)
	                break;
	            unmount.push([iter, iter.parentNode || target, null, null]);
	        }
	        // So now we're going to traverse the next node.
	        if (iter)
	            iter = iter.nextSibling;
	    } while (iter);
	    for (var _i = 0, unmount_1 = unmount; _i < unmount_1.length; _i++) {
	        var tuple = unmount_1[_i];
	        _apply_unmount(tuple);
	    }
	}
	exports._unmount = _unmount;
	/**
	 * Call mount and unmount on the node controllers.
	 */
	function applyMutations(records) {
	    var i = 0;
	    for (var _i = 0, records_1 = records; _i < records_1.length; _i++) {
	        var record = records_1[_i];
	        var target = record.target;
	        var added = record.addedNodes;
	        for (i = 0; i < added.length; i++)
	            if (added[i].parentNode)
	                _mount(added[i], target);
	        var removed = record.removedNodes;
	        for (i = 0; i < removed.length; i++)
	            _unmount(removed[i], target, record.previousSibling, record.nextSibling);
	    }
	}
	exports.applyMutations = applyMutations;
	/**
	 * Set up the mounting mechanism.
	 *
	 * @param node: the root node from which we will listen to the document
	 *    mutations.
	 */
	function setupMounting(node) {
	    var mutator = new MutationObserver(applyMutations);
	    mutator.observe(node, {
	        subtree: true,
	        childList: true
	    });
	}
	exports.setupMounting = setupMounting;


/***/ }
/******/ ])
});
;

},{}]},{},[1])(1)
});
//# sourceMappingURL=bundle.js.map
